'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }(); /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         */


exports.default = ButtonInternals;

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _styledComponents = require('./styled-components');

var _utils = require('./utils');

var _overrides = require('../helpers/overrides');

var _constants = require('./constants');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function ButtonInternals(props) {
  var children = props.children,
      overrides = props.overrides,
      startEnhancer = props.startEnhancer,
      endEnhancer = props.endEnhancer;

  var _getOverrides = (0, _overrides.getOverrides)(overrides.StartEnhancer, _styledComponents.StartEnhancer),
      _getOverrides2 = _slicedToArray(_getOverrides, 2),
      StartEnhancer = _getOverrides2[0],
      startEnhancerProps = _getOverrides2[1];

  var _getOverrides3 = (0, _overrides.getOverrides)(overrides.EndEnhancer, _styledComponents.EndEnhancer),
      _getOverrides4 = _slicedToArray(_getOverrides3, 2),
      EndEnhancer = _getOverrides4[0],
      endEnhancerProps = _getOverrides4[1];

  var sharedProps = (0, _utils.getSharedProps)(props);
  return React.createElement(
    React.Fragment,
    null,
    startEnhancer && React.createElement(
      StartEnhancer,
      _extends({}, sharedProps, startEnhancerProps),
      typeof startEnhancer === 'function' ? startEnhancer(sharedProps) : startEnhancer
    ),
    children,
    endEnhancer && React.createElement(
      EndEnhancer,
      _extends({}, sharedProps, endEnhancerProps),
      typeof endEnhancer === 'function' ? endEnhancer(sharedProps) : endEnhancer
    )
  );
}

ButtonInternals.defaultProps = {
  overrides: {},
  size: _constants.SIZE.default,
  kind: _constants.KIND.primary,
  shape: _constants.SHAPE.default,
  isLoading: false,
  disabled: false
};