'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.hasThumbnail = hasThumbnail;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _overrides = require('../helpers/overrides');

var _styledComponents = require('./styled-components');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function hasThumbnail(props) {
  return Boolean(props.thumbnail);
}

function Card(props) {
  var action = props.action,
      children = props.children,
      hasThumbnail = props.hasThumbnail,
      headerImage = props.headerImage,
      thumbnailSrc = props.thumbnail,
      title = props.title,
      overrides = props.overrides,
      otherProps = _objectWithoutProperties(props, ['action', 'children', 'hasThumbnail', 'headerImage', 'thumbnail', 'title', 'overrides']);

  var ActionOverride = overrides.Action,
      BodyOverride = overrides.Body,
      ContentsOverride = overrides.Contents,
      HeaderImageOverride = overrides.HeaderImage,
      RootOverride = overrides.Root,
      ThumbnailOverride = overrides.Thumbnail,
      TitleOverride = overrides.Title;


  var Action = (0, _overrides.getOverride)(ActionOverride) || _styledComponents.Action;
  var Body = (0, _overrides.getOverride)(BodyOverride) || _styledComponents.Body;
  var Contents = (0, _overrides.getOverride)(ContentsOverride) || _styledComponents.Contents;
  var HeaderImage = (0, _overrides.getOverride)(HeaderImageOverride) || _styledComponents.HeaderImage;
  var Root = (0, _overrides.getOverride)(RootOverride) || _styledComponents.Root;
  var Thumbnail = (0, _overrides.getOverride)(ThumbnailOverride) || _styledComponents.Thumbnail;
  var Title = (0, _overrides.getOverride)(TitleOverride) || _styledComponents.Title;

  var $hasThumbnail = hasThumbnail(props);
  return _react2.default.createElement(
    Root,
    _extends({}, otherProps, (0, _overrides.getOverrideProps)(RootOverride)),
    headerImage && _react2.default.createElement(HeaderImage, _extends({
      src: headerImage
    }, (0, _overrides.getOverrideProps)(HeaderImageOverride))),
    _react2.default.createElement(
      Contents,
      (0, _overrides.getOverrideProps)(ContentsOverride),
      thumbnailSrc && _react2.default.createElement(Thumbnail, _extends({
        src: thumbnailSrc
      }, (0, _overrides.getOverrideProps)(ThumbnailOverride))),
      title && _react2.default.createElement(
        Title,
        _extends({
          $hasThumbnail: $hasThumbnail
        }, (0, _overrides.getOverrideProps)(TitleOverride)),
        title
      ),
      _react2.default.createElement(
        Body,
        (0, _overrides.getOverrideProps)(BodyOverride),
        children
      ),
      action && _react2.default.createElement(
        Action,
        null,
        action
      )
    )
  );
}

Card.defaultProps = {
  action: null,
  children: null,
  hasThumbnail: hasThumbnail,
  overrides: {}
};

exports.default = Card;