'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _examples$TEXT_ONLY$e;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ = require('./');

var _button = require('../button');

var _overrides = require('../helpers/overrides');

var _images = require('./images');

var _examplesList = require('./examples-list');

var _examplesList2 = _interopRequireDefault(_examplesList);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; } /*
                                                                                                                                                                                                                             Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                             
                                                                                                                                                                                                                             This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                             LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                             */


var cardWidth = '328px';
var placeholderTitle = 'Card Title Entry';
var placeholderText = 'Proin ut dui sed metus pharetra hend rerit vel non mi. Nulla ornare faucibus ex, non facilisis nisl. Maecenas aliquet mauris ut tempus cursus. Etiam semper luctus sem ac blandit. ';

var Card = function Card(props) {
  var overrides = props.overrides,
      otherProps = _objectWithoutProperties(props, ['overrides']);

  var cardOverrides = (0, _overrides.mergeOverrides)({
    Root: {
      style: {
        width: cardWidth
      }
    }
  }, overrides);
  //$FlowFixMe
  return _react2.default.createElement(_.Card, _extends({}, otherProps, { overrides: cardOverrides }));
};
Card.defaultProps = {
  hasThumbnail: _.hasThumbnail,
  overrides: {}
};

exports.default = (_examples$TEXT_ONLY$e = {}, _defineProperty(_examples$TEXT_ONLY$e, _examplesList2.default.TEXT_ONLY, function Story1() {
  return _react2.default.createElement(
    Card,
    null,
    _react2.default.createElement(
      _.StyledBody,
      null,
      placeholderText
    )
  );
}), _defineProperty(_examples$TEXT_ONLY$e, _examplesList2.default.TEXT_IMAGE, function Story2() {
  return _react2.default.createElement(
    Card,
    { headerImage: _images.header, title: placeholderTitle },
    placeholderText
  );
}), _defineProperty(_examples$TEXT_ONLY$e, _examplesList2.default.TEXT_IMAGE_LINK, function Story3() {
  return _react2.default.createElement(
    Card,
    { headerImage: _images.header, title: placeholderTitle },
    _react2.default.createElement(
      _.StyledBody,
      null,
      placeholderText
    ),
    _react2.default.createElement(
      _.StyledAction,
      null,
      _react2.default.createElement(
        'a',
        { href: '#' },
        'Link to a Place\xA0\xA0\xA0>'
      )
    )
  );
}), _defineProperty(_examples$TEXT_ONLY$e, _examplesList2.default.TEXT_IMAGE_BUTTON, function Story4() {
  return _react2.default.createElement(
    Card,
    { headerImage: _images.header, title: placeholderTitle },
    _react2.default.createElement(
      _.StyledBody,
      null,
      placeholderText
    ),
    _react2.default.createElement(
      _.StyledAction,
      null,
      _react2.default.createElement(
        _button.Button,
        { style: { width: '100%' } },
        'Button Label'
      )
    )
  );
}), _defineProperty(_examples$TEXT_ONLY$e, _examplesList2.default.TEXT_LINK, function Story5() {
  return _react2.default.createElement(
    Card,
    null,
    _react2.default.createElement(
      _.StyledTitle,
      null,
      placeholderTitle
    ),
    _react2.default.createElement(
      _.StyledBody,
      null,
      placeholderText
    ),
    _react2.default.createElement(
      _.StyledAction,
      null,
      _react2.default.createElement(
        'a',
        { href: '#' },
        'Link to a Place\xA0\xA0\xA0>'
      )
    )
  );
}), _defineProperty(_examples$TEXT_ONLY$e, _examplesList2.default.TEXT_BUTTON, function Story6() {
  return _react2.default.createElement(
    Card,
    null,
    _react2.default.createElement(
      _.StyledTitle,
      null,
      placeholderTitle
    ),
    _react2.default.createElement(
      _.StyledBody,
      null,
      placeholderText
    ),
    _react2.default.createElement(
      _.StyledAction,
      null,
      _react2.default.createElement(
        _button.Button,
        { style: { width: '100%' } },
        'Button Label'
      )
    )
  );
}), _defineProperty(_examples$TEXT_ONLY$e, _examplesList2.default.HEADLINE_TEXT_THUMBNAIL, function Story7() {
  return _react2.default.createElement(
    Card,
    { thumbnail: _images.thumbnail, title: placeholderTitle },
    _react2.default.createElement(
      _.StyledBody,
      null,
      placeholderText
    ),
    _react2.default.createElement(
      _.StyledAction,
      null,
      _react2.default.createElement(
        _button.Button,
        { style: { width: '100%' } },
        'Button Label'
      )
    )
  );
}), _defineProperty(_examples$TEXT_ONLY$e, _examplesList2.default.HEADLINE_IMAGE, function Story8() {
  return _react2.default.createElement(Card, { headerImage: _images.header, title: placeholderTitle });
}), _defineProperty(_examples$TEXT_ONLY$e, _examplesList2.default.HEADLINE_TEXT, function Story9() {
  return _react2.default.createElement(
    Card,
    null,
    _react2.default.createElement(
      _.StyledTitle,
      null,
      placeholderTitle
    ),
    _react2.default.createElement(
      _.StyledBody,
      null,
      placeholderText
    )
  );
}), _defineProperty(_examples$TEXT_ONLY$e, _examplesList2.default.THUMBNAIL_LINK, function Story10() {
  return _react2.default.createElement(
    Card,
    { thumbnail: _images.thumbnail, title: placeholderTitle },
    _react2.default.createElement(
      _.StyledBody,
      null,
      placeholderText
    ),
    _react2.default.createElement(
      _.StyledAction,
      null,
      _react2.default.createElement(
        'a',
        { href: '#' },
        'Link to a Place\xA0\xA0\xA0>'
      )
    )
  );
}), _defineProperty(_examples$TEXT_ONLY$e, _examplesList2.default.THUMBNAIL_BUTTON, function Story11() {
  return _react2.default.createElement(
    Card,
    { thumbnail: _images.thumbnail, title: placeholderTitle },
    _react2.default.createElement(
      _.StyledBody,
      null,
      placeholderText
    ),
    _react2.default.createElement(
      _.StyledAction,
      null,
      _react2.default.createElement(
        _button.Button,
        { style: { width: '100%' } },
        'Button Label'
      )
    )
  );
}), _defineProperty(_examples$TEXT_ONLY$e, _examplesList2.default.KITCHEN_SINK_PROPS, function Story12() {
  return _react2.default.createElement(
    Card,
    {
      action: _react2.default.createElement(
        _button.Button,
        { style: { width: '100%' } },
        'Button Label'
      ),
      headerImage: _images.header,
      title: placeholderTitle,
      thumbnail: _images.thumbnail
    },
    placeholderText
  );
}), _defineProperty(_examples$TEXT_ONLY$e, _examplesList2.default.KITCHEN_SINK_COMPOSED, function Story13() {
  return _react2.default.createElement(
    Card,
    { headerImage: _images.header },
    _react2.default.createElement(_.StyledThumbnail, { src: _images.thumbnail }),
    _react2.default.createElement(
      _.StyledTitle,
      { $hasThumbnail: true },
      placeholderTitle
    ),
    _react2.default.createElement(
      _.StyledBody,
      null,
      placeholderText
    ),
    _react2.default.createElement(
      _.StyledAction,
      null,
      _react2.default.createElement(
        _button.Button,
        { style: { width: '100%' } },
        'Button Label'
      )
    )
  );
}), _examples$TEXT_ONLY$e);