'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Title = exports.Thumbnail = exports.Root = exports.HeaderImage = exports.Contents = exports.Body = exports.Action = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _index = require('../styles/index');

var Action = exports.Action = (0, _index.styled)('div', function () {
  return {};
});

var Body = exports.Body = (0, _index.styled)('div', function (_ref) {
  var $theme = _ref.$theme;
  var colors = $theme.colors,
      sizing = $theme.sizing,
      typography = $theme.typography;

  return _extends({
    marginBottom: sizing.scale600,
    color: colors.mono800
  }, typography.font400);
});

var Contents = exports.Contents = (0, _index.styled)('div', function (_ref2) {
  var $theme = _ref2.$theme;
  var sizing = $theme.sizing;

  return {
    margin: sizing.scale600
  };
});

var HeaderImage = exports.HeaderImage = (0, _index.styled)('img', function (_ref3) {
  var $theme = _ref3.$theme;
  var borders = $theme.borders;

  return {
    borderTopLeftRadius: borders.radius200,
    borderTopRightRadius: borders.radius200,
    objectFit: 'contain',
    maxWidth: '100%'
  };
});

var Root = exports.Root = (0, _index.styled)('div', function (_ref4) {
  var $theme = _ref4.$theme;
  var borders = $theme.borders,
      lighting = $theme.lighting;

  return _extends({}, borders.border300, {
    boxShadow: lighting.shadow400,
    borderRadius: borders.radius200
  });
});

var Thumbnail = exports.Thumbnail = (0, _index.styled)('img', function (props) {
  var _props$$theme = props.$theme,
      borders = _props$$theme.borders,
      sizing = _props$$theme.sizing;

  return _extends({
    float: 'right',
    height: sizing.scale2400,
    width: sizing.scale2400,
    objectFit: 'cover',
    borderRadius: borders.radius200
  }, borders.border200, {
    margin: '0 0 ' + sizing.scale500 + ' ' + sizing.scale500
  });
});

var Title = exports.Title = (0, _index.styled)('h1', function (_ref5) {
  var $hasThumbnail = _ref5.$hasThumbnail,
      $theme = _ref5.$theme;
  var colors = $theme.colors,
      sizing = $theme.sizing,
      typography = $theme.typography;

  return _extends({}, typography.font600, {
    color: colors.black,
    fontSize: $hasThumbnail ? sizing.scale600 : sizing.scale700,
    fontWeight: 500,
    margin: '0 0 ' + sizing.scale300 + ' 0',
    padding: 0
  });
});