'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _overrides = require('../helpers/overrides');

var _styledComponents = require('./styled-components');

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */


var StatelessCheckbox = function (_React$Component) {
  _inherits(StatelessCheckbox, _React$Component);

  function StatelessCheckbox() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, StatelessCheckbox);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = StatelessCheckbox.__proto__ || Object.getPrototypeOf(StatelessCheckbox)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      isFocused: _this.props.autoFocus || false,
      isHovered: false,
      isActive: false
    }, _this.onMouseEnter = function (e) {
      _this.setState({ isHovered: true });
      _this.props.onMouseEnter(e);
    }, _this.onMouseLeave = function (e) {
      _this.setState({ isHovered: false, isActive: false });
      _this.props.onMouseLeave(e);
    }, _this.onMouseDown = function (e) {
      _this.setState({ isActive: true });
      _this.props.onMouseDown(e);
    }, _this.onMouseUp = function (e) {
      _this.setState({ isActive: false });
      _this.props.onMouseUp(e);
    }, _this.onFocus = function (e) {
      _this.setState({ isFocused: true });
      _this.props.onFocus(e);
    }, _this.onBlur = function (e) {
      _this.setState({ isFocused: false });
      _this.props.onBlur(e);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(StatelessCheckbox, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          autoFocus = _props.autoFocus,
          inputRef = _props.inputRef;

      if (autoFocus && inputRef.current) {
        inputRef.current.focus();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var checkmarkType = this.props.checkmarkType;
      var _props2 = this.props,
          _props2$overrides = _props2.overrides,
          overrides = _props2$overrides === undefined ? {} : _props2$overrides,
          onChange = _props2.onChange,
          _props2$labelPlacemen = _props2.labelPlacement,
          labelPlacement = _props2$labelPlacemen === undefined ? checkmarkType === _constants.STYLE_TYPE.toggle ? 'left' : 'right' : _props2$labelPlacemen,
          inputRef = _props2.inputRef,
          isIndeterminate = _props2.isIndeterminate,
          isError = _props2.isError,
          disabled = _props2.disabled,
          value = _props2.value,
          name = _props2.name,
          type = _props2.type,
          checked = _props2.checked,
          children = _props2.children,
          required = _props2.required;
      var RootOverride = overrides.Root,
          CheckmarkOverride = overrides.Checkmark,
          LabelOverride = overrides.Label,
          InputOverride = overrides.Input;


      var Root = (0, _overrides.getOverride)(RootOverride) || _styledComponents.Root;
      var Checkmark = (0, _overrides.getOverride)(CheckmarkOverride) || _styledComponents.Checkmark;
      var Label = (0, _overrides.getOverride)(LabelOverride) || _styledComponents.Label;
      var Input = (0, _overrides.getOverride)(InputOverride) || _styledComponents.Input;

      var inputEvents = {
        onChange: onChange,
        onFocus: this.onFocus,
        onBlur: this.onBlur
      };
      var mouseEvents = {
        onMouseEnter: this.onMouseEnter,
        onMouseLeave: this.onMouseLeave,
        onMouseDown: this.onMouseDown,
        onMouseUp: this.onMouseUp
      };
      var sharedProps = {
        $isFocused: this.state.isFocused,
        $isHovered: this.state.isHovered,
        $isActive: this.state.isActive,
        $isError: isError,
        $checked: checked,
        $isIndeterminate: isIndeterminate,
        $required: required,
        $disabled: disabled,
        $value: value,
        $checkmarkType: checkmarkType
      };
      var labelComp = _react2.default.createElement(
        Label,
        _extends({
          $labelPlacement: labelPlacement
        }, sharedProps, (0, _overrides.getOverrideProps)(LabelOverride)),
        children
      );
      return _react2.default.createElement(
        Root,
        _extends({
          $labelPlacement: labelPlacement
        }, sharedProps, mouseEvents, (0, _overrides.getOverrideProps)(RootOverride)),
        (labelPlacement === 'top' || labelPlacement === 'left') && labelComp,
        _react2.default.createElement(Checkmark, _extends({
          checked: checked
        }, sharedProps, (0, _overrides.getOverrideProps)(CheckmarkOverride))),
        _react2.default.createElement(Input, _extends({
          value: value,
          name: name,
          checked: checked,
          required: required,
          'aria-invalid': isError || null,
          'aria-required': required || null,
          disabled: disabled,
          type: type,
          $ref: inputRef
        }, sharedProps, inputEvents, (0, _overrides.getOverrideProps)(InputOverride))),
        (labelPlacement === 'bottom' || labelPlacement === 'right') && labelComp
      );
    }
  }]);

  return StatelessCheckbox;
}(_react2.default.Component);

StatelessCheckbox.defaultProps = {
  overrides: {},
  checked: false,
  disabled: false,
  autoFocus: false,
  isIndeterminate: false,
  inputRef: _react2.default.createRef(),
  isError: false,
  type: 'checkbox',
  checkmarkType: _constants.STYLE_TYPE.default,
  onChange: function onChange() {},
  onMouseEnter: function onMouseEnter() {},
  onMouseLeave: function onMouseLeave() {},
  onMouseDown: function onMouseDown() {},
  onMouseUp: function onMouseUp() {},
  onFocus: function onFocus() {},
  onBlur: function onBlur() {}
};
exports.default = StatelessCheckbox;