'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ControlContainer = exports.Caption = exports.Label = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /*
                                                                                                                                                                                                                                                                  Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                  This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                  LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                  */


var _styles = require('../styles');

var Label = exports.Label = (0, _styles.styled)('label', function (props) {
  var $disabled = props.$disabled,
      _props$$theme = props.$theme,
      colors = _props$$theme.colors,
      sizing = _props$$theme.sizing,
      typography = _props$$theme.typography;

  return _extends({}, typography.font350, {
    fontWeight: 500,
    color: $disabled ? colors.mono700 : colors.mono1000,
    cursor: $disabled ? 'not-allowed' : 'auto',
    display: 'block',
    paddingTop: '0',
    paddingRight: '0',
    paddingBottom: '0',
    paddingLeft: '0',
    marginTop: sizing.scale300,
    marginRight: '0',
    marginBottom: sizing.scale300,
    marginLeft: '0'
  });
});

var Caption = exports.Caption = (0, _styles.styled)('div', function (props) {
  var $error = props.$error,
      _props$$theme2 = props.$theme,
      colors = _props$$theme2.colors,
      sizing = _props$$theme2.sizing,
      typography = _props$$theme2.typography;

  return _extends({}, typography.font200, {
    color: $error && typeof $error !== 'boolean' ? colors.negative400 : colors.mono800,
    paddingTop: '0',
    paddingRight: '0',
    paddingBottom: '0',
    paddingLeft: '0',
    marginTop: sizing.scale300,
    marginRight: '0',
    marginBottom: sizing.scale300,
    marginLeft: '0'
  });
});

var ControlContainer = exports.ControlContainer = (0, _styles.styled)('div', function (props) {
  var sizing = props.$theme.sizing;

  return {
    marginBottom: sizing.scale600
  };
});