'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.default = Icon;

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _overrides = require('../helpers/overrides');

var _styledComponents = require('./styled-components');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; } /*
                                                                                                                                                                                                                             Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                             
                                                                                                                                                                                                                             This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                             LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                             */


function Icon(props) {
  var children = props.children,
      title = props.title,
      _props$overrides = props.overrides,
      overrides = _props$overrides === undefined ? {} : _props$overrides,
      size = props.size,
      color = props.color,
      restProps = _objectWithoutProperties(props, ['children', 'title', 'overrides', 'size', 'color']);

  var sharedProps = {
    $size: size,
    $color: color
  };

  var _getOverrides = (0, _overrides.getOverrides)(overrides.Svg, _styledComponents.Svg),
      _getOverrides2 = _slicedToArray(_getOverrides, 2),
      Svg = _getOverrides2[0],
      overrideProps = _getOverrides2[1];

  return React.createElement(
    Svg,
    _extends({}, sharedProps, restProps, overrideProps),
    title ? React.createElement(
      'title',
      null,
      title
    ) : null,
    children
  );
}