'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.default = OptionProfile;

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _styledComponents = require('./styled-components');

var _overrides = require('../helpers/overrides');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }
// Components


// Types
function OptionProfile(_ref) {
  var item = _ref.item,
      getProfileItemLabels = _ref.getProfileItemLabels,
      getProfileItemImg = _ref.getProfileItemImg,
      getProfileItemImgText = _ref.getProfileItemImgText,
      _ref$overrides = _ref.overrides,
      overrides = _ref$overrides === undefined ? {} : _ref$overrides,
      restProps = _objectWithoutProperties(_ref, ['item', 'getProfileItemLabels', 'getProfileItemImg', 'getProfileItemImgText', 'overrides']);

  var _getOverrides = (0, _overrides.getOverrides)(overrides.ListItemProfile, _styledComponents.ListItemProfile),
      _getOverrides2 = _slicedToArray(_getOverrides, 2),
      ListItemProfile = _getOverrides2[0],
      listItemProfileProps = _getOverrides2[1];

  var _getOverrides3 = (0, _overrides.getOverrides)(overrides.ProfileImgContainer, _styledComponents.ProfileImgContainer),
      _getOverrides4 = _slicedToArray(_getOverrides3, 2),
      ProfileImgContainer = _getOverrides4[0],
      profileImgContainerProps = _getOverrides4[1];

  var _getOverrides5 = (0, _overrides.getOverrides)(overrides.ProfileImg, _styledComponents.ProfileImg),
      _getOverrides6 = _slicedToArray(_getOverrides5, 2),
      ProfileImg = _getOverrides6[0],
      profileImgProps = _getOverrides6[1];

  var _getOverrides7 = (0, _overrides.getOverrides)(overrides.ProfileLabelsContainer, _styledComponents.ProfileLabelsContainer),
      _getOverrides8 = _slicedToArray(_getOverrides7, 2),
      ProfileLabelsContainer = _getOverrides8[0],
      profileLabelsContainerProps = _getOverrides8[1];

  var _getOverrides9 = (0, _overrides.getOverrides)(overrides.ProfileTitle, _styledComponents.ProfileTitle),
      _getOverrides10 = _slicedToArray(_getOverrides9, 2),
      ProfileTitle = _getOverrides10[0],
      profileTitleProps = _getOverrides10[1];

  var _getOverrides11 = (0, _overrides.getOverrides)(overrides.ProfileSubtitle, _styledComponents.ProfileSubtitle),
      _getOverrides12 = _slicedToArray(_getOverrides11, 2),
      ProfileSubtitle = _getOverrides12[0],
      profileSubtitleProps = _getOverrides12[1];

  var _getOverrides13 = (0, _overrides.getOverrides)(overrides.ProfileBody, _styledComponents.ProfileBody),
      _getOverrides14 = _slicedToArray(_getOverrides13, 2),
      ProfileBody = _getOverrides14[0],
      profileBodyProps = _getOverrides14[1];

  var ItemImg = getProfileItemImg(item);

  var _getProfileItemLabels = getProfileItemLabels(item),
      title = _getProfileItemLabels.title,
      subtitle = _getProfileItemLabels.subtitle,
      body = _getProfileItemLabels.body;

  return React.createElement(
    ListItemProfile,
    _extends({}, restProps, listItemProfileProps),
    React.createElement(
      ProfileImgContainer,
      profileImgContainerProps,
      ItemImg && (typeof ItemImg === 'string' ?
      // Render img src string wrapped with image component
      React.createElement(ProfileImg, _extends({
        src: ItemImg,
        alt: getProfileItemImgText(item)
      }, profileImgProps)) :
      // Or just render the entire component user specified
      React.createElement(ItemImg, profileImgProps))
    ),
    React.createElement(
      ProfileLabelsContainer,
      profileLabelsContainerProps,
      title && React.createElement(
        ProfileTitle,
        profileTitleProps,
        title
      ),
      subtitle && React.createElement(
        ProfileSubtitle,
        profileSubtitleProps,
        subtitle
      ),
      body && React.createElement(
        ProfileBody,
        profileBodyProps,
        body
      )
    )
  );
}