'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _constants = require('./constants');

var _utils = require('./utils');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */

// Files


// Types
var MenuStatefulContainer = function (_React$Component) {
  _inherits(MenuStatefulContainer, _React$Component);

  function MenuStatefulContainer() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, MenuStatefulContainer);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = MenuStatefulContainer.__proto__ || Object.getPrototypeOf(MenuStatefulContainer)).call.apply(_ref, [this].concat(args))), _this), _this.state = _extends({}, _this.props.initialState), _this.refList = [], _this.rootRef = React.createRef(), _this.onKeyDown = function (event) {
      // Up arrow
      switch (event.key) {
        case _constants.KEY_STRINGS.ArrowUp:
        case _constants.KEY_STRINGS.ArrowDown:
          _this.handleArrowKey(event.key);
          event.preventDefault();
          event.stopPropagation();
          break;
        case _constants.KEY_STRINGS.Enter:
          _this.handleEnterKey(event);
          event.preventDefault();
          break;
      }
    }, _this.getRequiredItemProps = function (item, index) {
      var highlightedIndex = _this.state.highlightedIndex;
      var _this$props = _this.props,
          onItemSelect = _this$props.onItemSelect,
          getRequiredItemProps = _this$props.getRequiredItemProps;

      var onClickHandler = void 0;
      if (onItemSelect) {
        onClickHandler = onItemSelect.bind(null, { item: item });
      }
      // Create and store ref or re-use
      var itemRef = _this.refList[index];
      if (!itemRef) {
        itemRef = React.createRef();
        _this.refList[index] = itemRef;
      }
      return _extends({
        ref: itemRef,
        isHighlighted: highlightedIndex === index,
        onClick: onClickHandler,
        'aria-activedescendant': highlightedIndex === index
      }, getRequiredItemProps(item, index));
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(MenuStatefulContainer, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (typeof document !== 'undefined') {
        // TODO(#185): perhaps only bind event listener on focus
        document.addEventListener('keydown', this.onKeyDown);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (typeof document !== 'undefined') {
        document.removeEventListener('keydown', this.onKeyDown);
      }
    }

    // One array to hold all of list item refs


    // We need to have access to the root component user renders
    // to correctly facilitate keyboard scrolling behavior

  }, {
    key: 'internalSetState',


    // Internal set state function that will also invoke stateReducer
    value: function internalSetState(changeType, changes) {
      var stateReducer = this.props.stateReducer;

      this.setState(stateReducer(changeType, changes, this.state));
    }

    // Regular type here because this is not done through React

  }, {
    key: 'handleArrowKey',


    // Handler for arrow keys
    value: function handleArrowKey(key) {
      var items = this.props.items;
      var oldIndex = this.state.highlightedIndex;

      var highlightedIndex = oldIndex;
      var stateChangeType = null;
      if (key === _constants.KEY_STRINGS.ArrowUp) {
        highlightedIndex = Math.max(0, oldIndex - 1);
        stateChangeType = _constants.STATE_CHANGE_TYPES.moveUp;
      } else if (key === _constants.KEY_STRINGS.ArrowDown) {
        highlightedIndex = Math.min(oldIndex + 1, items.length - 1);
        stateChangeType = _constants.STATE_CHANGE_TYPES.moveDown;
      }
      (0, _utils.scrollItemIntoView)({
        node: this.refList[highlightedIndex],
        parentNode: this.rootRef,
        isFirst: highlightedIndex === 0,
        isLast: highlightedIndex === items.length - 1
      });
      this.internalSetState(stateChangeType, { highlightedIndex: highlightedIndex });
    }

    // Handler for enter key

  }, {
    key: 'handleEnterKey',
    value: function handleEnterKey(event) {
      var _props = this.props,
          items = _props.items,
          onItemSelect = _props.onItemSelect;
      var highlightedIndex = this.state.highlightedIndex;

      if (items[highlightedIndex] && onItemSelect) {
        onItemSelect({ item: items[highlightedIndex], event: event });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var highlightedIndex = this.state.highlightedIndex;
      var _props2 = this.props,
          children = _props2.children,
          items = _props2.items;

      return children({
        highlightedIndex: highlightedIndex,
        items: items,
        rootRef: this.rootRef,
        getRequiredItemProps: this.getRequiredItemProps
      });
    }
  }]);

  return MenuStatefulContainer;
}(React.Component);

MenuStatefulContainer.defaultProps = {
  initialState: {
    // We start the index at -1 to indicate that no highlighting exists initially
    highlightedIndex: -1
  },
  stateReducer: function stateReducer(changeType, changes) {
    return changes;
  },
  onItemSelect: function onItemSelect() {},
  getRequiredItemProps: function getRequiredItemProps() {
    return {};
  },
  children: function children() {
    return null;
  }
};
exports.default = MenuStatefulContainer;