'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ProfileBody = exports.ProfileSubtitle = exports.ProfileTitle = exports.ProfileLabelsContainer = exports.ProfileImg = exports.ProfileImgContainer = exports.ListItemProfile = exports.ListItem = exports.List = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /*
                                                                                                                                                                                                                                                                  Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                  
                                                                                                                                                                                                                                                                  This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                  LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                  */


var _styles = require('../styles');

var _constants = require('./constants');

var List = exports.List = (0, _styles.styled)('ul', function (_ref) {
  var $theme = _ref.$theme;
  return {
    position: 'relative',
    margin: 0,
    padding: 0,
    background: $theme.colors.white,
    borderRadius: $theme.borders.radius300,
    boxShadow: $theme.lighting.shadow600,
    overflow: 'auto'
  };
});

var ListItem = exports.ListItem = (0, _styles.styled)('li', function (_ref2) {
  var $theme = _ref2.$theme,
      $isHighlighted = _ref2.$isHighlighted,
      $size = _ref2.$size;
  return _extends({}, $size === _constants.OPTION_LIST_SIZE.compact ? $theme.typography.font200 : $theme.typography.font300, {
    position: 'relative',
    display: 'block',
    color: $isHighlighted ? $theme.colors.primary : $theme.colors.black,
    cursor: 'pointer',
    transitionProperty: 'color, background-color',
    transitionDuration: $theme.animation.timing100,
    transitionTimingFunction: $theme.animation.easeOutCurve,
    ':hover': {
      backgroundColor: $theme.colors.mono300
    },
    paddingTop: $size === _constants.OPTION_LIST_SIZE.compact ? $theme.sizing.scale100 : $theme.sizing.scale300,
    paddingBottom: $size === _constants.OPTION_LIST_SIZE.compact ? $theme.sizing.scale100 : $theme.sizing.scale300,
    paddingRight: $size === _constants.OPTION_LIST_SIZE.compact ? $theme.sizing.scale900 : $theme.sizing.scale600,
    paddingLeft: $size === _constants.OPTION_LIST_SIZE.compact ? $theme.sizing.scale900 : $theme.sizing.scale600,
    ':first-child': {
      marginTop: $theme.sizing.scale300
    },
    ':last-child': {
      marginBottom: $theme.sizing.scale300
    }
  });
});

var ListItemProfile = exports.ListItemProfile = (0, _styles.styled)('li', function (_ref3) {
  var $theme = _ref3.$theme;
  return {
    position: 'relative',
    display: 'flex',
    alignItems: 'center',
    cursor: 'pointer',
    paddingTop: $theme.sizing.scale300,
    paddingBottom: $theme.sizing.scale300,
    paddingRight: $theme.sizing.scale800,
    paddingLeft: $theme.sizing.scale800,
    transitionProperty: 'color, background-color',
    transitionDuration: $theme.animation.timing100,
    transitionTimingFunction: $theme.animation.easeOutCurve,
    ':hover': {
      backgroundColor: $theme.colors.mono300
    },
    ':first-child': {
      marginTop: $theme.sizing.scale300
    },
    ':last-child': {
      marginBottom: $theme.sizing.scale300
    }
  };
});

var ProfileImgContainer = exports.ProfileImgContainer = (0, _styles.styled)('div', {
  width: '60px',
  height: '60px',
  display: 'flex',
  justifyContent: 'center',
  alignItems: 'center'
});

var ProfileImg = exports.ProfileImg = (0, _styles.styled)('img', {
  width: '100%',
  height: '100%',
  borderRadius: '50%'
});

var ProfileLabelsContainer = exports.ProfileLabelsContainer = (0, _styles.styled)('div', function (_ref4) {
  var $theme = _ref4.$theme;
  return {
    marginLeft: $theme.sizing.scale600,
    alignSelf: 'flex-start',
    display: 'flex',
    flexDirection: 'column'
  };
});

var ProfileTitle = exports.ProfileTitle = (0, _styles.styled)('h6', function (_ref5) {
  var $theme = _ref5.$theme;
  return _extends({}, $theme.typography.font450, {
    color: $theme.colors.black,
    margin: 0
  });
});

var ProfileSubtitle = exports.ProfileSubtitle = (0, _styles.styled)('p', function (_ref6) {
  var $theme = _ref6.$theme;
  return _extends({}, $theme.typography.font300, {
    color: $theme.colors.black,
    margin: 0
  });
});

var ProfileBody = exports.ProfileBody = (0, _styles.styled)('p', function (_ref7) {
  var $theme = _ref7.$theme;
  return _extends({}, $theme.typography.font200, {
    margin: 0,
    color: $theme.colors.mono800
  });
});