'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = StatefulPagination;

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _pagination = require('./pagination');

var _pagination2 = _interopRequireDefault(_pagination);

var _statefulContainer = require('./stateful-container');

var _statefulContainer2 = _interopRequireDefault(_statefulContainer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; } /*
                                                                                                                                                                                                                             Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                             
                                                                                                                                                                                                                             This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                             LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                             */


function StatefulPagination(_ref) {
  var numPages = _ref.numPages,
      initialState = _ref.initialState,
      stateReducer = _ref.stateReducer,
      onPageChange = _ref.onPageChange,
      props = _objectWithoutProperties(_ref, ['numPages', 'initialState', 'stateReducer', 'onPageChange']);

  return React.createElement(
    _statefulContainer2.default,
    {
      numPages: numPages,
      initialState: initialState,
      stateReducer: stateReducer,
      onPageChange: onPageChange
    },
    function (renderProps) {
      return React.createElement(_pagination2.default, _extends({ numPages: numPages }, renderProps, props));
    }
  );
}

StatefulPagination.defaultProps = _extends({}, _statefulContainer2.default.defaultProps, _pagination2.default.defaultProps);