'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
var PLACEMENT = exports.PLACEMENT = {
  auto: 'auto',
  topLeft: 'topLeft',
  top: 'top',
  topRight: 'topRight',
  rightTop: 'rightTop',
  right: 'right',
  rightBottom: 'rightBottom',
  bottomRight: 'bottomRight',
  bottom: 'bottom',
  bottomLeft: 'bottomLeft',
  leftBottom: 'leftBottom',
  left: 'left',
  leftTop: 'leftTop'
};

var TRIGGER_TYPE = exports.TRIGGER_TYPE = {
  click: 'click',
  hover: 'hover'
};

var STATE_CHANGE_TYPE = exports.STATE_CHANGE_TYPE = {
  open: 'open',
  close: 'close'
};

var ACCESSIBILITY_TYPE = exports.ACCESSIBILITY_TYPE = {
  none: 'none',
  menu: 'menu',
  tooltip: 'tooltip'
};

var POPOVER_MARGIN = exports.POPOVER_MARGIN = 8;

var ARROW_SIZE = exports.ARROW_SIZE = 6;

/**
 * Since we use a 45-degree rotated div to render the arrow, the
 * width/height of this div is different than the arrow size itself
 *
 * The arrow size is essentially half the diagonal of the rotated div,
 * using pythagorean theorem:
 *   width^2 + height^2 = (arrow_size * 2)^2
 * In this case width = height so:
 *   2 * width^2 = (arrow_size * 2)^2
 * Simplifies to:
 *   width = √((arrow_size * 2)^2 / 2)
 */
var ARROW_WIDTH = exports.ARROW_WIDTH = Math.ceil(Math.sqrt(Math.pow(ARROW_SIZE * 2, 2) / 2));