'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.tests = exports.suite = undefined;

var _tests$SIMPLE_EXAMPLE;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _styles = require('../styles');

var _index = require('./index');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */


var suite = exports.suite = 'ProgressBar Test Suite';
var tests = exports.tests = {
  SIMPLE_EXAMPLE: 'ProgressBar component',
  STYLE_PROPS_OVERRIDES: 'ProgressBar style and props overrides',
  CUSTOM_SUCCESS_VALUE: 'ProgressBar with custom success value of 2000',
  SIMPLE_EXAMPLE_WITH_HIDDEN_LABEL: 'ProgressBar with hidden label'
};
var updateProgress = void 0;

var ProgressBarContainer = function (_React$Component) {
  _inherits(ProgressBarContainer, _React$Component);

  function ProgressBarContainer() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ProgressBarContainer);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ProgressBarContainer.__proto__ || Object.getPrototypeOf(ProgressBarContainer)).call.apply(_ref, [this].concat(args))), _this), _this.state = { value: _this.props.value }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ProgressBarContainer, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      updateProgress = setInterval(function () {
        var newValue = _this2.state.value < _this2.props.successValue ? (_this2.state.value + Math.round(Math.random() * 10 * _this2.props.successValue / 100)) % _this2.props.successValue : 0;
        _this2.setState({ value: newValue });
      }, 1000);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearInterval(updateProgress);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          getProgressLabel = _props.getProgressLabel,
          showLabel = _props.showLabel;

      var extraProps = getProgressLabel ? { getProgressLabel: getProgressLabel } : {};
      return React.createElement(
        Centered,
        null,
        React.createElement(_index.ProgressBar, _extends({
          showLabel: showLabel,
          overrides: this.props.overrides,
          value: this.state.value,
          successValue: this.props.successValue
        }, extraProps))
      );
    }
  }]);

  return ProgressBarContainer;
}(React.Component);

ProgressBarContainer.defaultProps = {
  value: 0,
  successValue: 100,
  showLabel: true,
  overrides: {}
};


var Centered = (0, _styles.styled)('div', {
  display: 'flex',
  alignItems: 'center',
  height: '90vh'
});

exports.default = (_tests$SIMPLE_EXAMPLE = {}, _defineProperty(_tests$SIMPLE_EXAMPLE, tests.SIMPLE_EXAMPLE, function Story1() {
  return React.createElement(ProgressBarContainer, null);
}), _defineProperty(_tests$SIMPLE_EXAMPLE, tests.CUSTOM_SUCCESS_VALUE, function Story2() {
  return React.createElement(ProgressBarContainer, {
    successValue: 2000,
    getProgressLabel: function getProgressLabel(value, successValue) {
      return value + ' out of ' + successValue + ' loaded';
    }
  });
}), _defineProperty(_tests$SIMPLE_EXAMPLE, tests.SIMPLE_EXAMPLE_WITH_HIDDEN_LABEL, function Story3() {
  return React.createElement(ProgressBarContainer, { showLabel: false });
}), _defineProperty(_tests$SIMPLE_EXAMPLE, tests.STYLE_PROPS_OVERRIDES, function Story4() {
  return React.createElement(ProgressBarContainer, {
    getProgressLabel: function getProgressLabel(value, successValue) {
      return Math.round(value / successValue * 100) + '% Loaded Successfully';
    },
    overrides: {
      BarProgress: {
        style: function style(_ref2) {
          var $theme = _ref2.$theme,
              $value = _ref2.$value;

          return {
            backgroundColor: 'red',
            position: 'relative',
            ':after': {
              position: 'absolute',
              content: '"' + $value + '%"',
              right: '0px'
            }
          };
        }
      },
      Bar: {
        style: function style(_ref3) {
          var $theme = _ref3.$theme,
              $value = _ref3.$value;

          return {
            height: '20px'
          };
        }
      }
    }
  });
}), _tests$SIMPLE_EXAMPLE);