'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */


var defaultStateReducer = function defaultStateReducer(type, nextState) {
  return nextState;
};

var StatefulRadioGroupContainer = function (_React$Component) {
  _inherits(StatefulRadioGroupContainer, _React$Component);

  function StatefulRadioGroupContainer(props) {
    _classCallCheck(this, StatefulRadioGroupContainer);

    var _this = _possibleConstructorReturn(this, (StatefulRadioGroupContainer.__proto__ || Object.getPrototypeOf(StatefulRadioGroupContainer)).call(this, props));

    _this.onChange = function (e) {
      _this.stateReducer(_constants.STATE_TYPE.change, e);
      var onChange = _this.props.onChange;

      onChange && onChange(e);
    };

    _this.stateReducer = function (type, e) {
      var nextState = {};
      var stateReducer = _this.props.stateReducer;

      if (type === _constants.STATE_TYPE.change) {
        nextState = { value: e.target.value };
      }
      var newState = stateReducer(type, nextState, _this.state, e);
      _this.setState(newState);
    };

    var initialState = _this.props.initialState;

    _this.state = _extends({}, initialState);
    return _this;
  }

  _createClass(StatefulRadioGroupContainer, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          _props$children = _props.children,
          children = _props$children === undefined ? function (childProps) {
        return null;
      } : _props$children,
          initialState = _props.initialState,
          stateReducer = _props.stateReducer,
          rest = _objectWithoutProperties(_props, ['children', 'initialState', 'stateReducer']);

      var onChange = this.onChange;

      return children(_extends({}, rest, this.state, {
        onChange: onChange
      }));
    }
  }]);

  return StatefulRadioGroupContainer;
}(_react2.default.Component);

StatefulRadioGroupContainer.defaultProps = {
  initialState: {
    value: ''
  },
  stateReducer: defaultStateReducer,
  onChange: function onChange() {}
};
exports.default = StatefulRadioGroupContainer;