'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */


var defaultStateReducer = function defaultStateReducer(type, nextState) {
  return nextState;
};

var StatefulSelectContainer = function (_React$Component) {
  _inherits(StatefulSelectContainer, _React$Component);

  function StatefulSelectContainer() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, StatefulSelectContainer);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = StatefulSelectContainer.__proto__ || Object.getPrototypeOf(StatefulSelectContainer)).call.apply(_ref, [this].concat(args))), _this), _this.state = _extends({}, _this.props.initialState), _this.onChange = function (params) {
      _this.internalSetState(params);
      var onChange = _this.props.onChange;

      return onChange(params);
    }, _this.onTextInputChange = function (e) {
      var onTextInputChange = _this.props.onTextInputChange;

      onTextInputChange && onTextInputChange(e);
    }, _this.onMouseEnter = function (e) {
      var onMouseEnter = _this.props.onMouseEnter;

      onMouseEnter && onMouseEnter(e);
    }, _this.onMouseLeave = function (e) {
      var onMouseLeave = _this.props.onMouseLeave;

      onMouseLeave && onMouseLeave(e);
    }, _this.onFocus = function (e) {
      var onFocus = _this.props.onFocus;

      onFocus && onFocus(e);
    }, _this.onBlur = function (e) {
      var onBlur = _this.props.onBlur;

      onBlur && onBlur(e);
    }, _this.internalSetState = function (params) {
      var nextState = {
        selectedOptions: params.selectedOptions
      };
      var stateReducer = _this.props.stateReducer;

      var newState = stateReducer(params.type, nextState, _this.state, params.event, params);
      _this.setState(newState);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(StatefulSelectContainer, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          _props$children = _props.children,
          children = _props$children === undefined ? function (childProps) {
        return null;
      } : _props$children,
          initialState = _props.initialState,
          stateReducer = _props.stateReducer,
          rest = _objectWithoutProperties(_props, ['children', 'initialState', 'stateReducer']);

      var onChange = this.onChange,
          onTextInputChange = this.onTextInputChange,
          onMouseEnter = this.onMouseEnter,
          onMouseLeave = this.onMouseLeave,
          onFocus = this.onFocus,
          onBlur = this.onBlur;

      return children(_extends({}, rest, this.state, {
        onChange: onChange,
        onTextInputChange: onTextInputChange,
        onMouseEnter: onMouseEnter,
        onMouseLeave: onMouseLeave,
        onFocus: onFocus,
        onBlur: onBlur
      }));
    }
  }]);

  return StatefulSelectContainer;
}(_react2.default.Component);

StatefulSelectContainer.defaultProps = {
  initialState: {
    selectedOptions: []
  },
  stateReducer: defaultStateReducer,
  onTextInputChange: function onTextInputChange() {},
  onChange: function onChange() {},
  onMouseEnter: function onMouseEnter() {},
  onMouseLeave: function onMouseLeave() {},
  onFocus: function onFocus() {},
  onBlur: function onBlur() {}
};
exports.default = StatefulSelectContainer;