'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Svg = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /*
                                                                                                                                                                                                                                                                  Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                  
                                                                                                                                                                                                                                                                  This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                  LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                  */


var _styles = require('../styles');

var _styledComponents = require('../icon/styled-components');

var spin = {
  from: {
    transform: 'rotate(0deg)'
  },
  to: {
    transform: 'rotate(360deg)'
  }
};

/**
 * Spinner icon overrides
 */
var Svg = exports.Svg = (0, _styles.styled)('svg', function (props) {
  var $theme = props.$theme,
      $color = props.$color;

  return _extends({}, (0, _styledComponents.getSvgStyles)(props), {
    fill: $color || $theme.colors.primary400,
    cursor: 'wait',
    animationName: spin,
    animationDuration: $theme.animation.timing700,
    animationIterationCount: 'infinite',
    animationTimingFunction: 'linear'
  });
});