'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _themes = require('../../themes');

var _createMockTheme = require('../../test/create-mock-theme');

var _createMockTheme2 = _interopRequireDefault(_createMockTheme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */


var MOCK_THEME = (0, _createMockTheme2.default)(_themes.LightTheme);

function styled(Base) {
  var _class, _temp2;

  var objOrFn = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  return _temp2 = _class = function (_React$Component) {
    _inherits(MockStyledComponent, _React$Component);

    function MockStyledComponent() {
      var _ref;

      var _temp, _this, _ret;

      _classCallCheck(this, MockStyledComponent);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = MockStyledComponent.__proto__ || Object.getPrototypeOf(MockStyledComponent)).call.apply(_ref, [this].concat(args))), _this), _this.state = {}, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(MockStyledComponent, [{
      key: 'getStyles',
      value: function getStyles() {
        return this.state.styles;
      }
    }, {
      key: 'getPassedProps',
      value: function getPassedProps() {
        var props = this.props;

        return Object.keys(props).reduce(function (acc, key) {
          if (key[0] !== '$') {
            acc[key] = props[key];
          }
          return acc;
        }, {});
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2.default.createElement(Base, _extends({ 'styled-component': 'true' }, this.getPassedProps()));
      }
    }], [{
      key: 'getDerivedStateFromProps',
      value: function getDerivedStateFromProps(props) {
        var styleFnArg = _extends({}, props, { $theme: MOCK_THEME });

        var styles = typeof objOrFn === 'function' ? objOrFn(styleFnArg) : objOrFn;

        // Check for runtime overrides
        var $style = props.$style;

        if (typeof $style === 'function') {
          $style = $style(styleFnArg);
        }
        if ($style) {
          styles = _extends({}, styles, $style);
        }

        return { styles: styles };
      }
    }]);

    return MockStyledComponent;
  }(_react2.default.Component), _class.displayName = 'MockStyledComponent', _temp2;
}

exports.default = styled;