'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /*
                                                                                                                                                                                                                                                                  Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                  
                                                                                                                                                                                                                                                                  This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                  LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                  */


exports.default = styledWrapper;

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _styletronReactCore = require('styletron-react-core');

var _styletronStandard = require('styletron-standard');

var _themeProvider = require('./theme-provider');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var wrapper = function wrapper(StyledComponent) {
  return function withThemeHOC(props) {
    return React.createElement(
      _themeProvider.ThemeContext.Consumer,
      null,
      function (theme) {
        return React.createElement(StyledComponent, _extends({}, props, { $theme: theme }));
      }
    );
  };
};

var baseStyled = (0, _styletronReactCore.createStyled)({ wrapper: wrapper, getInitialStyle: _styletronStandard.getInitialStyle, driver: _styletronStandard.driver });

// TODO: Need a flow expert to help remove this 'any' type
// eslint-disable-next-line flowtype/no-weak-types
function styledWrapper() {
  // If user is trying to style a styled component
  // use withStyleDeep, otherwise use baseStyled
  var styleFn = baseStyled;

  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  if (args[0] && args[0].__STYLETRON__) {
    styleFn = _styletronReactCore.withStyleDeep;
  }
  // Also allow passing deep style overrides via $style prop
  // Ex: <StyledDiv $style={{color: 'red'}} />
  // Issue for supporting this natively in styletron:
  // https://github.com/rtsao/styletron/issues/221
  return (0, _styletronReactCore.withStyleDeep)(styleFn.apply(undefined, _toConsumableArray(args)), function (props) {
    var $style = props.$style;

    if (typeof $style === 'function') {
      return $style(props);
    }
    return $style || {};
  });
}