'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _statefulContainer = require('./stateful-container');

var _statefulContainer2 = _interopRequireDefault(_statefulContainer);

var _component = require('./component');

var _component2 = _interopRequireDefault(_component);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; } /*
                                                                                                                                                                                                                             Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                             
                                                                                                                                                                                                                             This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                             LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                             */


function StatefulComponent(props) {
  var children = props.children,
      restProps = _objectWithoutProperties(props, ['children']);

  return React.createElement(
    _statefulContainer2.default,
    restProps,
    function (componentProps) {
      return React.createElement(
        _component2.default,
        componentProps,
        children
      );
    }
  );
}

StatefulComponent.defaultProps = _statefulContainer2.default.defaultProps;

exports.default = StatefulComponent;