'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withAll = exports.withThemeProvider = exports.withStyletronProvider = undefined;

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _styletronReact = require('styletron-react');

var _styletronEngineAtomic = require('styletron-engine-atomic');

var _styles = require('../styles');

var _themes = require('../themes');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var engine = new _styletronEngineAtomic.Client(); /*
                                                  Copyright (c) 2018 Uber Technologies, Inc.
                                                  
                                                  This source code is licensed under the MIT license found in the
                                                  LICENSE file in the root directory of this source tree.
                                                  */

var withStyletronProvider = exports.withStyletronProvider = function withStyletronProvider(Component) {
  return function withStyletronProviderHOC(props) {
    return React.createElement(
      _styletronReact.Provider,
      { value: engine },
      React.createElement(Component, props)
    );
  };
};

var withThemeProvider = exports.withThemeProvider = function withThemeProvider(Component) {
  return function withThemeProviderHOC(props) {
    return React.createElement(
      _styles.ThemeProvider,
      { theme: _themes.LightTheme },
      React.createElement(Component, props)
    );
  };
};

var withAll = exports.withAll = function withAll(Component) {
  return React.createElement(
    _styletronReact.Provider,
    { value: engine },
    React.createElement(
      _styles.ThemeProvider,
      { theme: _themes.LightTheme },
      Component()
    )
  );
};