'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.suite = undefined;

var _examples$SIMPLE_EXAM;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _styles = require('../styles');

var _index = require('./index');

var _button = require('../button');

var _examplesList = require('./examples-list');

var _examplesList2 = _interopRequireDefault(_examplesList);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */


var suite = exports.suite = 'Toast Test Suite';

var Centered = (0, _styles.styled)('div', {
  position: 'relative',
  display: 'flex',
  flexDirection: 'column',
  justifyContent: 'center',
  alignItems: 'center',
  lineHeight: 1.5
});
var Space = (0, _styles.styled)('span', {
  display: 'inline-block',
  lineHeight: 1.5,
  marginTop: '10px',
  marginRight: '10px',
  marginLeft: '10px'
});

var getBtnStyle = function getBtnStyle(color) {
  return function (_ref) {
    var $theme = _ref.$theme;

    var hoverStyle = { backgroundColor: $theme.colors[color + '500'] };
    var activeStyle = { backgroundColor: $theme.colors[color + '600'] };
    return {
      backgroundColor: $theme.colors[color],
      ':hover:enabled': hoverStyle,
      ':focus:enabled': hoverStyle,
      ':active:enabled': activeStyle
    };
  };
};

var ToasterExample = function (_React$Component) {
  _inherits(ToasterExample, _React$Component);

  function ToasterExample() {
    var _ref2;

    var _temp, _this, _ret;

    _classCallCheck(this, ToasterExample);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = ToasterExample.__proto__ || Object.getPrototypeOf(ToasterExample)).call.apply(_ref2, [this].concat(args))), _this), _this.add = function (kind, props) {
      return function () {
        var _this$getToastProps = _this.getToastProps(props),
            children = _this$getToastProps.children,
            toastProps = _objectWithoutProperties(_this$getToastProps, ['children']);

        _index.toaster[kind](children, toastProps);
      };
    }, _this.addInfo = _this.add(_index.KIND.info), _this.addPositive = _this.add(_index.KIND.positive), _this.addWarning = _this.add(_index.KIND.warning), _this.addNegative = _this.add(_index.KIND.negative), _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ToasterExample, [{
    key: 'getToastProps',
    value: function getToastProps(props) {
      return _extends({
        onClose: function onClose() {
          // eslint-disable-next-line no-console
          console.log('Toast dismissed');
        },
        autoHideDuration: 5000,
        children: 'Lorem ipsum dolor sit amet, consectetur adipiscing elit.'
      }, props);
    }
  }, {
    key: 'render',
    value: function render() {
      return React.createElement(
        'div',
        null,
        React.createElement(
          _button.Button,
          { onClick: this.addInfo },
          'Info toast'
        ),
        React.createElement(Space, null),
        React.createElement(
          _button.Button,
          {
            onClick: this.addPositive,
            overrides: {
              BaseButton: {
                style: getBtnStyle('positive')
              }
            }
          },
          'Success toast'
        ),
        React.createElement(Space, null),
        React.createElement(
          _button.Button,
          {
            onClick: this.addWarning,
            overrides: {
              BaseButton: {
                style: getBtnStyle('warning')
              }
            }
          },
          'Warning toast'
        ),
        React.createElement(Space, null),
        React.createElement(
          _button.Button,
          {
            onClick: this.addNegative,
            overrides: {
              BaseButton: {
                style: getBtnStyle('negative')
              }
            }
          },
          'Negative toast'
        )
      );
    }
  }]);

  return ToasterExample;
}(React.Component);

var ToasterAdvancedExample = function (_React$Component2) {
  _inherits(ToasterAdvancedExample, _React$Component2);

  function ToasterAdvancedExample() {
    var _ref3;

    var _temp2, _this2, _ret2;

    _classCallCheck(this, ToasterAdvancedExample);

    for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    return _ret2 = (_temp2 = (_this2 = _possibleConstructorReturn(this, (_ref3 = ToasterAdvancedExample.__proto__ || Object.getPrototypeOf(ToasterAdvancedExample)).call.apply(_ref3, [this].concat(args))), _this2), _this2.state = { cleared: false }, _temp2), _possibleConstructorReturn(_this2, _ret2);
  }

  _createClass(ToasterAdvancedExample, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.addNotifications();
    }
  }, {
    key: 'addNotifications',
    value: function addNotifications() {
      _index.toaster.info('Info notification', { closeable: false });
      _index.toaster.positive(React.createElement(
        'span',
        null,
        'Positive notification'
      ));
      this.keyToUpdate = _index.toaster.warning('Warning notification');
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      return React.createElement(
        'div',
        null,
        React.createElement(
          Space,
          null,
          React.createElement(
            _button.Button,
            {
              onClick: function onClick() {
                var kind = {
                  '0': _index.KIND.info,
                  '1': _index.KIND.positive,
                  '2': _index.KIND.warning
                }[Math.floor(Math.random() * Math.floor(3))];
                _index.toaster.update(_this3.keyToUpdate, {
                  kind: kind,
                  children: 'Updated ' + kind + ' notification'
                });
              }
            },
            'Update to random'
          )
        ),
        React.createElement(
          Space,
          null,
          React.createElement(
            _button.Button,
            {
              onClick: function onClick() {
                _index.toaster.clear();
                _this3.setState({ cleared: true });
              }
            },
            'Clear all'
          )
        ),
        React.createElement(
          Space,
          null,
          React.createElement(
            _button.Button,
            {
              disabled: !this.state.cleared,
              onClick: function onClick() {
                _this3.addNotifications();
                _this3.setState({ cleared: false });
              }
            },
            'Add toasts'
          )
        )
      );
    }
  }]);

  return ToasterAdvancedExample;
}(React.Component);

exports.default = (_examples$SIMPLE_EXAM = {}, _defineProperty(_examples$SIMPLE_EXAM, _examplesList2.default.SIMPLE_EXAMPLE, function Story1() {
  return React.createElement(
    Centered,
    null,
    React.createElement(
      _index.Toast,
      null,
      'Default info notification'
    ),
    React.createElement(
      _index.Toast,
      { closeable: false },
      function (_ref4) {
        var dismiss = _ref4.dismiss;

        return React.createElement(
          React.Fragment,
          null,
          'Info notification with no close button and children as a function.',
          React.createElement(
            Centered,
            null,
            React.createElement(
              Space,
              null,
              React.createElement(
                _button.Button,
                {
                  onClick: dismiss,
                  kind: _button.KIND.secondary,
                  size: _button.SIZE.compact
                },
                'Click to dismiss'
              )
            )
          )
        );
      }
    ),
    React.createElement(
      _index.Toast,
      { kind: _index.KIND.positive },
      'Positive notification'
    ),
    React.createElement(
      _index.Toast,
      { kind: _index.KIND.warning },
      'Warning notification'
    ),
    React.createElement(
      _index.Toast,
      { kind: _index.KIND.negative },
      'Negative notification'
    )
  );
}), _defineProperty(_examples$SIMPLE_EXAM, _examplesList2.default.TOASTER_EXAMPLE, function Story2() {
  return React.createElement(
    Centered,
    null,
    _index.toaster.create({ placement: _index.PLACEMENT.bottomRight }),
    React.createElement(ToasterExample, null)
  );
}), _defineProperty(_examples$SIMPLE_EXAM, _examplesList2.default.TOASTER_ADVANCED_EXAMPLE, function Story2() {
  return React.createElement(
    Centered,
    null,
    _index.toaster.create({ placement: _index.PLACEMENT.bottom }),
    React.createElement(ToasterAdvancedExample, null)
  );
}), _defineProperty(_examples$SIMPLE_EXAM, _examplesList2.default.OVERRIDES_EXAMPLE, function Story3() {
  return React.createElement(
    Centered,
    null,
    React.createElement(
      _index.Toast,
      {
        overrides: {
          Body: {
            style: {
              backgroundImage: 'linear-gradient(#400080, transparent), linear-gradient(200deg, #d047d1, #ff0000, #ffff00)'
            }
          },
          CloseIcon: {
            props: {
              title: 'Close'
            },
            style: {
              backgroundColor: '#fff',
              color: '#000',
              borderRadius: '50%'
            }
          }
        }
      },
      'Toast with overrides'
    )
  );
}), _examples$SIMPLE_EXAM);