'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _overrides = require('../helpers/overrides');

var _icon = require('../icon');

var _styledComponents = require('./styled-components');

var _constants = require('./constants');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */


var Toast = function (_React$Component) {
  _inherits(Toast, _React$Component);

  function Toast() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Toast);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Toast.__proto__ || Object.getPrototypeOf(Toast)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      isAnimating: false,
      isHidden: true
    }, _this.animateIn = function () {
      _this.setState({ isHidden: false, isAnimating: true });
    }, _this.animateOut = function () {
      var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function () {};

      _this.setState({ isAnimating: true });
      // Remove the toast from the DOM after animation finishes
      _this.animateOutCompleteTimer = setTimeout(function () {
        _this.setState({ isAnimating: false });
        callback();
      }, 600);
    }, _this.dismiss = function () {
      _this.animateOut(_this.props.onClose);
      _this.setState({
        isHidden: true
      });
    }, _this.onFocus = function (e) {
      _this.clearTimeout();
      typeof _this.props.onFocus === 'function' && _this.props.onFocus(e);
    }, _this.onMouseEnter = function (e) {
      _this.clearTimeout();
      typeof _this.props.onMouseEnter === 'function' && _this.props.onMouseEnter(e);
    }, _this.onBlur = function (e) {
      _this.startTimeout();
      typeof _this.props.onBlur === 'function' && _this.props.onBlur(e);
    }, _this.onMouseLeave = function (e) {
      _this.startTimeout();
      typeof _this.props.onMouseLeave === 'function' && _this.props.onMouseLeave(e);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Toast, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.animateIn();
      this.startTimeout();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.clearTimeout();
    }
  }, {
    key: 'startTimeout',
    value: function startTimeout() {
      if (this.props.autoHideDuration) {
        this.autoHideTimeout = setTimeout(this.dismiss, this.props.autoHideDuration);
      }
    }
  }, {
    key: 'clearTimeout',
    value: function (_clearTimeout) {
      function clearTimeout() {
        return _clearTimeout.apply(this, arguments);
      }

      clearTimeout.toString = function () {
        return _clearTimeout.toString();
      };

      return clearTimeout;
    }(function () {
      [this.autoHideTimeout, this.animateOutCompleteTimer].forEach(function (timerId) {
        if (timerId) {
          clearTimeout(timerId);
        }
      });
    })
  }, {
    key: 'getSharedProps',
    value: function getSharedProps() {
      var _props = this.props,
          kind = _props.kind,
          closeable = _props.closeable;
      var _state = this.state,
          isHidden = _state.isHidden,
          isAnimating = _state.isAnimating;

      return {
        $kind: kind,
        $closeable: closeable,
        $isHidden: isHidden,
        $isAnimating: isAnimating
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          children = _props2.children,
          closeable = _props2.closeable;
      var _state2 = this.state,
          isAnimating = _state2.isAnimating,
          isHidden = _state2.isHidden;
      var _props$overrides = this.props.overrides,
          BodyOverride = _props$overrides.Body,
          CloseIconOverride = _props$overrides.CloseIcon;

      // $FlowFixMe

      var _getOverrides = (0, _overrides.getOverrides)(BodyOverride, _styledComponents.Body),
          _getOverrides2 = _slicedToArray(_getOverrides, 2),
          Body = _getOverrides2[0],
          bodyProps = _getOverrides2[1];

      var _getOverrides3 = (0, _overrides.getOverrides)(
      // $FlowFixMe
      CloseIconOverride,
      // $FlowFixMe
      _styledComponents.CloseIconSvg),
          _getOverrides4 = _slicedToArray(_getOverrides3, 2),
          CloseIcon = _getOverrides4[0],
          closeIconProps = _getOverrides4[1];

      var closeIconOverrides = (0, _overrides.mergeOverrides)({ Svg: CloseIcon },
      // $FlowFixMe
      { Svg: CloseIconOverride });

      var sharedProps = this.getSharedProps();

      if (isHidden && !isAnimating) {
        return null;
      }
      return React.createElement(
        Body,
        _extends({
          tabIndex: 0,
          role: 'alert'
        }, sharedProps, bodyProps, {
          // the properties below have to go after overrides
          onBlur: this.onBlur,
          onFocus: this.onFocus,
          onMouseEnter: this.onMouseEnter,
          onMouseLeave: this.onMouseLeave
        }),
        closeable ? React.createElement(_icon.Delete, _extends({
          onClick: this.dismiss
        }, sharedProps, closeIconProps, {
          overrides: closeIconOverrides
        })) : null,
        typeof children === 'function' ? children({ dismiss: this.dismiss }) : children
      );
    }
  }]);

  return Toast;
}(React.Component);

Toast.defaultProps = {
  autoHideDuration: 0,
  closeable: true,
  kind: _constants.KIND.info,
  // Do we need a separate handler for
  // when a notification dismisses automatically
  onClose: function onClose() {},
  onBlur: function onBlur() {},
  onFocus: function onFocus() {},
  onMouseEnter: function onMouseEnter() {},
  onMouseLeave: function onMouseLeave() {},
  overrides: {}
};
exports.default = Toast;