'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _examples$SIMPLE_EXAM;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /*
                                                                                                                                                                                                                                                                  Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                  
                                                                                                                                                                                                                                                                  This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                  LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                  */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('../styles');

var _button = require('../button');

var _index = require('./index');

var _examplesList = require('./examples-list');

var _examplesList2 = _interopRequireDefault(_examplesList);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Centered = (0, _styles.styled)('div', {
  position: 'relative',
  display: 'flex',
  flexDirection: 'column',
  justifyContent: 'center',
  alignItems: 'center',
  height: '90vh',
  lineHeight: 1.5
});

var FakeLink = (0, _styles.styled)('span', function (props) {
  return {
    borderBottom: '1px dotted ' + props.$theme.colors.primary500,
    color: props.$theme.colors.primary500
  };
});

var Paragraph = (0, _styles.styled)('p', function (props) {
  return {
    margin: '0 0 8px',
    ':last-child': {
      marginBottom: '0px'
    }
  };
});

var Anchor = (0, _styles.styled)('a', function (props) {
  return {
    color: 'white'
  };
});

var Grid = (0, _styles.styled)('div', {
  display: 'grid',
  gridTemplateColumns: '20% 20% 20% 20% 20%',
  gridTemplateRows: '20% 20% 20% 20% 20%',
  width: '380px',
  height: '250px'
});

var GridItem = (0, _styles.styled)('div', function (_ref) {
  var row = _ref.row,
      col = _ref.col;
  return {
    gridColumnStart: col,
    gridRowStart: row,
    textAlign: 'center'
  };
});

exports.default = (_examples$SIMPLE_EXAM = {}, _defineProperty(_examples$SIMPLE_EXAM, _examplesList2.default.SIMPLE_EXAMPLE, function Story1() {
  return _react2.default.createElement(
    Centered,
    null,
    _react2.default.createElement(
      'div',
      { style: { maxWidth: '360px' } },
      'You can use tooltips in many places, including inline text',
      ' ',
      _react2.default.createElement(
        _index.StatefulTooltip,
        {
          accessibilityType: 'tooltip',
          content: 'Tooltips display short messages.'
        },
        _react2.default.createElement(
          FakeLink,
          { tabIndex: '0' },
          'such as this'
        )
      ),
      '. Tooltips are essentially just a Popover with a few style tweaks, so you can use all the features that Popover supports.'
    )
  );
}), _defineProperty(_examples$SIMPLE_EXAM, _examplesList2.default.MULTILINE, function Story2() {
  return _react2.default.createElement(
    Centered,
    null,
    _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        _index.StatefulTooltip,
        {
          content: 'Tooltips don\'t have a maximum width by default, but you can set one easily through the overrides prop. The default typography styles make multi-line text look great.',
          overrides: { Inner: { style: { maxWidth: '200px' } } }
        },
        _react2.default.createElement(
          FakeLink,
          { tabIndex: '0' },
          'Hover Me'
        )
      )
    )
  );
}), _defineProperty(_examples$SIMPLE_EXAM, _examplesList2.default.COMPLEX_CONTENT, function Story3() {
  return _react2.default.createElement(
    Centered,
    null,
    _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        _index.StatefulTooltip,
        {
          content: _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(
              Paragraph,
              null,
              'Tooltips also support rendering arbitrary content.'
            ),
            _react2.default.createElement(
              Paragraph,
              null,
              'This in includes paragraphs,',
              ' ',
              _react2.default.createElement(
                Anchor,
                {
                  href: 'https://www.youtube.com/watch?v=dQw4w9WgXcQ',
                  target: '_blank',
                  rel: 'noopener noreferrer'
                },
                'links'
              ),
              ', and any other markup.'
            )
          ),
          overrides: { Inner: { style: { maxWidth: '200px' } } }
        },
        _react2.default.createElement(
          FakeLink,
          { tabIndex: '0' },
          'Hover Me'
        )
      )
    )
  );
}), _defineProperty(_examples$SIMPLE_EXAM, _examplesList2.default.VIA_CLICK, function Story4() {
  return _react2.default.createElement(
    Centered,
    null,
    _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        _index.StatefulTooltip,
        { triggerType: _index.TRIGGER_TYPE.click, content: 'Bonjour!' },
        _react2.default.createElement(
          _button.Button,
          null,
          'Click Me'
        )
      )
    )
  );
}), _defineProperty(_examples$SIMPLE_EXAM, _examplesList2.default.PLACEMENTS, function Story5() {
  var sharedProps = {
    triggerType: _index.TRIGGER_TYPE.click,
    content: 'Bonjour!'
  };
  return _react2.default.createElement(
    Centered,
    null,
    _react2.default.createElement(
      Grid,
      null,
      _react2.default.createElement(
        GridItem,
        { row: 1, col: 2 },
        _react2.default.createElement(
          _index.StatefulTooltip,
          _extends({}, sharedProps, { placement: _index.PLACEMENT.topLeft }),
          _react2.default.createElement(
            _button.Button,
            null,
            'TL'
          )
        )
      ),
      _react2.default.createElement(
        GridItem,
        { row: 1, col: 3 },
        _react2.default.createElement(
          _index.StatefulTooltip,
          _extends({}, sharedProps, { placement: _index.PLACEMENT.top }),
          _react2.default.createElement(
            _button.Button,
            null,
            'Top'
          )
        )
      ),
      _react2.default.createElement(
        GridItem,
        { row: 1, col: 4 },
        _react2.default.createElement(
          _index.StatefulTooltip,
          _extends({}, sharedProps, { placement: _index.PLACEMENT.topRight }),
          _react2.default.createElement(
            _button.Button,
            null,
            'TR'
          )
        )
      ),
      _react2.default.createElement(
        GridItem,
        { row: 2, col: 1 },
        _react2.default.createElement(
          _index.StatefulTooltip,
          _extends({}, sharedProps, { placement: _index.PLACEMENT.leftTop }),
          _react2.default.createElement(
            _button.Button,
            null,
            'LT'
          )
        )
      ),
      _react2.default.createElement(
        GridItem,
        { row: 3, col: 1 },
        _react2.default.createElement(
          _index.StatefulTooltip,
          _extends({}, sharedProps, { placement: _index.PLACEMENT.left }),
          _react2.default.createElement(
            _button.Button,
            null,
            'Left'
          )
        )
      ),
      _react2.default.createElement(
        GridItem,
        { row: 4, col: 1 },
        _react2.default.createElement(
          _index.StatefulTooltip,
          _extends({}, sharedProps, { placement: _index.PLACEMENT.leftBottom }),
          _react2.default.createElement(
            _button.Button,
            null,
            'LB'
          )
        )
      ),
      _react2.default.createElement(
        GridItem,
        { row: 5, col: 2 },
        _react2.default.createElement(
          _index.StatefulTooltip,
          _extends({}, sharedProps, { placement: _index.PLACEMENT.bottomLeft }),
          _react2.default.createElement(
            _button.Button,
            null,
            'BL'
          )
        )
      ),
      _react2.default.createElement(
        GridItem,
        { row: 5, col: 3 },
        _react2.default.createElement(
          _index.StatefulTooltip,
          _extends({}, sharedProps, { placement: _index.PLACEMENT.bottom }),
          _react2.default.createElement(
            _button.Button,
            null,
            'Bottom'
          )
        )
      ),
      _react2.default.createElement(
        GridItem,
        { row: 5, col: 4 },
        _react2.default.createElement(
          _index.StatefulTooltip,
          _extends({}, sharedProps, { placement: _index.PLACEMENT.bottomRight }),
          _react2.default.createElement(
            _button.Button,
            null,
            'BR'
          )
        )
      ),
      _react2.default.createElement(
        GridItem,
        { row: 2, col: 5 },
        _react2.default.createElement(
          _index.StatefulTooltip,
          _extends({}, sharedProps, { placement: _index.PLACEMENT.rightTop }),
          _react2.default.createElement(
            _button.Button,
            null,
            'RT'
          )
        )
      ),
      _react2.default.createElement(
        GridItem,
        { row: 3, col: 5 },
        _react2.default.createElement(
          _index.StatefulTooltip,
          _extends({}, sharedProps, { placement: _index.PLACEMENT.right }),
          _react2.default.createElement(
            _button.Button,
            null,
            'Right'
          )
        )
      ),
      _react2.default.createElement(
        GridItem,
        { row: 4, col: 5 },
        _react2.default.createElement(
          _index.StatefulTooltip,
          _extends({}, sharedProps, { placement: _index.PLACEMENT.rightBottom }),
          _react2.default.createElement(
            _button.Button,
            null,
            'RB'
          )
        )
      )
    )
  );
}), _defineProperty(_examples$SIMPLE_EXAM, _examplesList2.default.STYLE_OVERRIDES, function Story6() {
  return _react2.default.createElement(
    Centered,
    null,
    _react2.default.createElement(
      _index.StatefulTooltip,
      {
        initialState: { isOpen: true },
        showArrow: true,
        overrides: {
          Arrow: {
            style: {
              backgroundColor: 'lavender'
            }
          },
          Body: {
            style: {
              backgroundColor: 'lavender',
              borderRadius: 0
            }
          },
          Inner: {
            style: {
              backgroundColor: 'lavender',
              borderRadius: 0,
              color: '#8181a0',
              fontSize: '28px',
              lineHeight: 1.2,
              fontStyle: 'italic'
            }
          }
        },
        content: 'Bonjour!'
      },
      _react2.default.createElement(
        FakeLink,
        { tabIndex: '0' },
        'Hover Me'
      )
    )
  );
}), _examples$SIMPLE_EXAM);