'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Arrow = exports.Inner = exports.Body = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /*
                                                                                                                                                                                                                                                                  Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                  
                                                                                                                                                                                                                                                                  This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                  LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                  */


var _styles = require('../styles');

var _styledComponents = require('../popover/styled-components');

var _utils = require('../popover/utils');

/**
 * We want to reuse the default Popover styles and add our overrides
 * for Tooltip. Normally you could do something like
 * withStyleDeep(StyledPopoverBody, {...}), however this break the
 * ability to use $style properly–the style overrides passed in by
 * the customer will override the base styles but not the styles
 * specified here.
 *
 * We could create our own withStyleDeep that also takes the $style
 * prop into account
 */
var Body = exports.Body = (0, _styles.styled)('div', function (props) {
  return _extends({}, (0, _styledComponents.getBodyStyles)(props), {
    // Tooltip
    backgroundColor: props.$theme.tooltip.backgroundColor,
    borderRadius: props.$theme.borders.radius200,
    boxShadow: props.$theme.lighting.shadow400,
    color: props.$theme.colors.mono100,
    // Reset transition property to opacity only, and static transform
    transitionProperty: 'opacity',
    transform: (0, _utils.getEndPosition)(props.$popoverOffset)
  });
});

var Inner = exports.Inner = (0, _styles.styled)('div', function (props) {
  return _extends({}, (0, _styledComponents.getInnerStyles)(props), {
    backgroundColor: props.$theme.tooltip.backgroundColor,
    borderRadius: props.$theme.borders.radius200,
    paddingTop: props.$theme.sizing.scale300,
    paddingBottom: props.$theme.sizing.scale300,
    paddingLeft: props.$theme.sizing.scale300,
    paddingRight: props.$theme.sizing.scale300
  }, props.$theme.typography.font200);
});

var Arrow = exports.Arrow = (0, _styles.styled)('div', function (props) {
  return _extends({}, (0, _styledComponents.getArrowStyles)(props), {
    backgroundColor: props.$theme.tooltip.backgroundColor
  });
});