'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = deepMerge;
function deepMerge(target) {
  target = target || {};

  for (var _len = arguments.length, sources = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    sources[_key - 1] = arguments[_key];
  }

  var len = sources.length;
  var obj = void 0;
  var value = void 0;
  for (var i = 0; i < len; i++) {
    obj = sources[i] || {};
    for (var key in obj) {
      if (obj.hasOwnProperty(key)) {
        value = obj[key];
        if (isCloneable(value)) {
          target[key] = deepMerge(target[key] || {}, value);
        } else {
          target[key] = value;
        }
      }
    }
  }
  return target;
}

/* eslint-disable-next-line flowtype/no-weak-types */
function isCloneable(obj) {
  return Array.isArray(obj) || {}.toString.call(obj) == '[object Object]';
}