'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _overrides = require('../helpers/overrides');

var _constants = require('./constants');

var _styledComponents = require('./styled-components');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */


function getSharedProps(props, mapper) {
  return Object.keys(props).reduce(function (newProps, propName) {
    var newName = mapper[propName] && '$' + propName;
    if (newName) {
      newProps[newName] = props[propName];
    }
    return newProps;
  }, {});
}

var FormControl = function (_React$Component) {
  _inherits(FormControl, _React$Component);

  function FormControl() {
    _classCallCheck(this, FormControl);

    return _possibleConstructorReturn(this, (FormControl.__proto__ || Object.getPrototypeOf(FormControl)).apply(this, arguments));
  }

  _createClass(FormControl, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          _props$overrides = _props.overrides,
          LabelOverride = _props$overrides.Label,
          CaptionOverride = _props$overrides.Caption,
          label = _props.label,
          caption = _props.caption,
          error = _props.error,
          children = _props.children;


      var onlyChildProps = React.Children.only(children).props;
      var sharedProps = getSharedProps(onlyChildProps, _constants.STYLETRON_PROP_MAPPER);
      sharedProps.$error = this.props.error || sharedProps.$error;
      var Label = (0, _overrides.getOverride)(LabelOverride) || _styledComponents.Label;
      var Caption = (0, _overrides.getOverride)(CaptionOverride) || _styledComponents.Caption;

      return React.createElement(
        React.Fragment,
        null,
        label && React.createElement(
          Label,
          _extends({
            htmlFor: onlyChildProps.id
          }, sharedProps, (0, _overrides.getOverrideProps)(LabelOverride)),
          typeof label === 'function' ? label(sharedProps) : label
        ),
        React.createElement(
          _styledComponents.ControlContainer,
          null,
          children,
          (caption || error) && React.createElement(
            Caption,
            _extends({}, sharedProps, (0, _overrides.getOverrideProps)(CaptionOverride)),
            error && typeof error !== 'boolean' ? typeof error === 'function' ? error(sharedProps) : error : typeof caption === 'function' ? caption(sharedProps) : caption
          )
        )
      );
    }
  }]);

  return FormControl;
}(React.Component);

FormControl.defaultProps = {
  overrides: {},
  label: null,
  caption: null,
  error: false
};
exports.default = FormControl;