#!/usr/bin/env node
'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var generateNewIcons = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
    var _this = this;

    var iconTemplate, svgs, prettierOptions, iconExports;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            iconTemplate = _fs2.default.readFileSync(_path2.default.resolve(__dirname, './icon-template.txt'), 'utf8');
            svgs = _fs2.default.readdirSync(_path2.default.resolve(__dirname, './svg')).filter(function (f) {
              return f.endsWith('.svg');
            });
            _context2.next = 4;
            return _prettier2.default.resolveConfig(__dirname);

          case 4:
            _context2.t0 = _context2.sent;

            if (_context2.t0) {
              _context2.next = 7;
              break;
            }

            _context2.t0 = {};

          case 7:
            prettierOptions = _context2.t0;
            iconExports = [];


            svgs.forEach(function () {
              var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(svgFilename) {
                var svgFile, componentName, svgFileContents, iconProps, viewBox, result;
                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        svgFile = svgFilename.split('.')[0];
                        componentName = pascalCase(svgFile);

                        iconExports.push('export {default as ' + componentName + '} from \'./' + svgFile + '\';');

                        svgFileContents = _fs2.default.readFileSync(_path2.default.resolve(__dirname, './svg/' + svgFilename), 'utf8');
                        iconProps = ['title="' + titleCase(svgFile) + '"'];
                        viewBox = svgFileContents.match(/viewBox="[^"]+"/);

                        if (viewBox) {
                          iconProps.push(viewBox[0]);
                        }

                        result = iconTemplate.replace('%%ICON_NAME%%', componentName).replace('%%ICON_PROPS%%', iconProps.join(' ')).replace('%%ICON_PATH%%', reactify(svgFileContents));


                        _fs2.default.writeFileSync(_path2.default.resolve(__dirname, './' + svgFile + '.js'), _prettier2.default.format(result, _extends({ parser: 'babylon' }, prettierOptions)));

                      case 9:
                      case 'end':
                        return _context.stop();
                    }
                  }
                }, _callee, _this);
              }));

              return function (_x) {
                return _ref2.apply(this, arguments);
              };
            }());

            _fs2.default.writeFileSync(_path2.default.resolve(__dirname, './icon-exports.js'), '// @flow\n' + iconExports.join('\n') + '\n');

            // eslint-disable-next-line no-console
            console.log('Wrote ' + svgs.length + ' icon(s)');

          case 12:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function generateNewIcons() {
    return _ref.apply(this, arguments);
  };
}();

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _prettier = require('prettier');

var _prettier2 = _interopRequireDefault(_prettier);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }
/*
Copyright (c) 2018 Uber Technologies, Inc.
 This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/

/* eslint-env node*/


function capitalize(str) {
  return str.charAt(0).toUpperCase() + str.slice(1);
}

function pascalCase(str) {
  return str.split('-').map(capitalize).join('');
}

function titleCase(str) {
  return str.split('-').map(capitalize).join(' ');
}

// transform svg string to properly styled jsx
function reactify(svgString) {
  return svgString.replace(/<\/?svg[^>]*>/gm, '').replace(/^\s*\n/gm, '').replace(/\n$/, '').replace(/\t/g, '  ').replace(/fill-rule/g, 'fillRule').replace(/clip-rule/g, 'clipRule').replace(/fill-opacity/g, 'fillOpacity').trim();
}

function cleanOldIcons() {
  var allJsFiles = _fs2.default.readdirSync(_path2.default.resolve(__dirname)).filter(function (f) {
    return f.endsWith('.js');
  });
  allJsFiles.forEach(function (f) {
    if (_fs2.default.readFileSync(_path2.default.resolve(__dirname, f), 'utf8').match(/^\/\/ BASEUI-GENERATED-REACT-ICON/m)) {
      _fs2.default.unlinkSync(_path2.default.resolve(__dirname, f));
    }
  });
}

cleanOldIcons();
generateNewIcons();