'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Svg = undefined;
exports.getSvgStyles = getSvgStyles;

var _styles = require('../styles');

function getSvgStyles(_ref) {
  var $theme = _ref.$theme,
      $size = _ref.$size,
      $color = _ref.$color;

  if ($size) {
    if ($theme.sizing.hasOwnProperty($size)) {
      $size = $theme.sizing[$size];
    } else if (typeof $size === 'number') {
      $size = $size + 'px';
    }
  } else {
    $size = $theme.sizing.scale800;
  }
  return {
    display: 'inline-block',
    fill: $color || 'currentColor',
    height: $size,
    width: $size
  };
} /*
  Copyright (c) 2018 Uber Technologies, Inc.
  
  This source code is licensed under the MIT license found in the
  LICENSE file in the root directory of this source tree.
  */

var Svg = exports.Svg = (0, _styles.styled)('svg', getSvgStyles);