'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }(); /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         */

// Components


exports.default = Menu;

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _styledComponents = require('./styled-components');

var _optionList = require('./option-list');

var _optionList2 = _interopRequireDefault(_optionList);

var _utils = require('./utils');

var _overrides = require('../helpers/overrides');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

// Types
function Menu(_ref) {
  var items = _ref.items,
      _ref$getRequiredItemP = _ref.getRequiredItemProps,
      getRequiredItemProps = _ref$getRequiredItemP === undefined ? function (item, index) {
    return {};
  } : _ref$getRequiredItemP,
      _ref$rootRef = _ref.rootRef,
      rootRef = _ref$rootRef === undefined ? React.createRef() : _ref$rootRef,
      _ref$overrides = _ref.overrides,
      overrides = _ref$overrides === undefined ? {} : _ref$overrides;

  var _getOverrides = (0, _overrides.getOverrides)(overrides.List, _styledComponents.List),
      _getOverrides2 = _slicedToArray(_getOverrides, 2),
      List = _getOverrides2[0],
      listProps = _getOverrides2[1];

  var _getOverrides3 = (0, _overrides.getOverrides)(overrides.Option, _optionList2.default),
      _getOverrides4 = _slicedToArray(_getOverrides3, 2),
      Option = _getOverrides4[0],
      optionProps = _getOverrides4[1];

  return React.createElement(
    List,
    _extends({ $ref: rootRef }, listProps),
    items.map(function (item, index) {
      var requiredProps = getRequiredItemProps(item, index);
      return React.createElement(Option, _extends({
        key: index,
        item: item,
        role: 'option'
        // Allows tab focus into first element
        , tabIndex: index === 0 ? 0 : -1
      }, (0, _utils.getSharedProps)(requiredProps), optionProps));
    })
  );
}