'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _examples$SIMPLE_EXAM;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _addonKnobs = require('@storybook/addon-knobs');

var _button = require('../button');

var _input = require('../input');

var _examplesList = require('./examples-list');

var _examplesList2 = _interopRequireDefault(_examplesList);

var _styles = require('../styles');

var _index = require('./index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */

/* global document */


var Centered = (0, _styles.styled)('div', {
  position: 'relative',
  display: 'flex',
  flexDirection: 'column',
  justifyContent: 'center',
  alignItems: 'center',
  height: '90vh'
});

var ModalStateContainer = function (_React$Component) {
  _inherits(ModalStateContainer, _React$Component);

  function ModalStateContainer() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ModalStateContainer);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ModalStateContainer.__proto__ || Object.getPrototypeOf(ModalStateContainer)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      isOpen: _this.props.isInitiallyOpen
    }, _this.toggle = function () {
      var open = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : !_this.state.isOpen;

      _this.setState({
        isOpen: Boolean(open)
      });
    }, _this.open = function () {
      _this.toggle(true);
    }, _this.close = function () {
      _this.toggle(false);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ModalStateContainer, [{
    key: 'render',
    value: function render() {
      return this.props.children(_extends({
        toggle: this.toggle,
        open: this.open,
        close: this.close,
        setState: this.setState.bind(this)
      }, this.state));
    }
  }]);

  return ModalStateContainer;
}(React.Component);

ModalStateContainer.defaultProps = {
  isInitiallyOpen: false
};


var sizeKnob = function sizeKnob() {
  return (0, _addonKnobs.select)('size', [_index.SIZE.default, _index.SIZE.full, _index.SIZE.auto, '800px', '50vw'], 'default');
};

exports.default = (_examples$SIMPLE_EXAM = {}, _defineProperty(_examples$SIMPLE_EXAM, _examplesList2.default.SIMPLE_EXAMPLE, function Story1() {
  return React.createElement(
    Centered,
    null,
    React.createElement(
      ModalStateContainer,
      { isInitiallyOpen: true },
      function (_ref2) {
        var open = _ref2.open,
            close = _ref2.close,
            isOpen = _ref2.isOpen;
        return React.createElement(
          React.Fragment,
          null,
          React.createElement(
            _button.Button,
            { onClick: open, className: 'open-modal-button' },
            'Open Modal'
          ),
          React.createElement(
            _index.Modal,
            { onClose: close, isOpen: isOpen, size: sizeKnob() },
            React.createElement(
              _index.ModalHeader,
              null,
              'Hello world'
            ),
            React.createElement(
              _index.ModalBody,
              null,
              'Proin ut dui sed metus pharetra hend rerit vel non mi. Nulla ornare faucibus ex, non facilisis nisl. Maecenas aliquet mauris ut tempus.'
            ),
            React.createElement(
              _index.ModalFooter,
              null,
              React.createElement(
                _index.ModalButton,
                { onClick: close },
                'Cancel'
              ),
              React.createElement(
                _index.ModalButton,
                { onClick: close },
                'Okay'
              )
            )
          )
        );
      }
    )
  );
}), _defineProperty(_examples$SIMPLE_EXAM, _examplesList2.default.SCROLLING_EXAMPLE, function Story2() {
  return React.createElement(
    Centered,
    null,
    React.createElement(
      ModalStateContainer,
      { isInitiallyOpen: true },
      function (_ref3) {
        var open = _ref3.open,
            close = _ref3.close,
            isOpen = _ref3.isOpen;
        return React.createElement(
          React.Fragment,
          null,
          React.createElement(
            _button.Button,
            { onClick: open },
            'Open Modal'
          ),
          React.createElement(
            _index.Modal,
            { onClose: close, isOpen: isOpen },
            React.createElement(
              _index.ModalHeader,
              null,
              'Hello world'
            ),
            React.createElement(
              _index.ModalBody,
              null,
              [0, 1, 2, 3, 4, 5, 6, 7, 8, 9].map(function (i) {
                return React.createElement(
                  'p',
                  { key: i },
                  'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec porta orci at elit commodo, ac interdum velit accumsan. Duis congue suscipit erat non blandit. In dapibus mi elit, quis mattis sapien lobortis ac. Duis sollicitudin congue dolor, ac tincidunt massa tincidunt eget. Fusce pretium, risus et consectetur venenatis, urna metus scelerisque est, ac malesuada est metus volutpat justo. Praesent ultrices, lectus ac tincidunt eleifend, augue mi maximus ante, non eleifend justo sem quis justo. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Morbi ante magna, blandit ut enim non, sollicitudin faucibus est. Aliquam a tellus fermentum urna finibus facilisis vitae in est.'
                );
              })
            ),
            React.createElement(
              _index.ModalFooter,
              null,
              React.createElement(
                _index.ModalButton,
                { onClick: close },
                'Cancel'
              ),
              React.createElement(
                _index.ModalButton,
                { onClick: close },
                'Okay'
              )
            )
          )
        );
      }
    )
  );
}), _defineProperty(_examples$SIMPLE_EXAM, _examplesList2.default.CLOSEABLE_EXAMPLE, function Story3() {
  return React.createElement(
    Centered,
    null,
    React.createElement(
      ModalStateContainer,
      { isInitiallyOpen: true },
      // $FlowFixMe
      function (_ref4) {
        var open = _ref4.open,
            close = _ref4.close,
            isOpen = _ref4.isOpen,
            setState = _ref4.setState,
            value = _ref4.value;
        return React.createElement(
          React.Fragment,
          null,
          React.createElement(
            _button.Button,
            { onClick: open },
            'Open Modal'
          ),
          React.createElement(
            _index.Modal,
            { onClose: close, isOpen: isOpen, closeable: false },
            React.createElement(
              _index.ModalHeader,
              null,
              'Please Authenticate'
            ),
            React.createElement(
              _index.ModalBody,
              null,
              React.createElement(
                'div',
                null,
                'This modal cannot be closed by the user. Enter',
                ' ',
                React.createElement(
                  'strong',
                  null,
                  'abc123'
                ),
                ' to continue:'
              ),
              React.createElement(
                'div',
                { style: { marginTop: '12px' } },
                React.createElement(_input.Input, {
                  value: value,
                  onChange:
                  // $FlowFixMe
                  function onChange(evt) {
                    return setState({ value: evt.target.value });
                  },
                  placeholder: 'Enter password'
                })
              )
            ),
            React.createElement(
              _index.ModalFooter,
              null,
              React.createElement(
                _index.ModalButton,
                { onClick: close, disabled: value !== 'abc123' },
                'Authenticate'
              )
            )
          )
        );
      }
    )
  );
}), _defineProperty(_examples$SIMPLE_EXAM, _examplesList2.default.MOUNT_NODE_EXAMPLE, function Story3() {
  var CustomMountNodeExample = function (_React$Component2) {
    _inherits(CustomMountNodeExample, _React$Component2);

    function CustomMountNodeExample() {
      var _ref5;

      var _temp2, _this2, _ret2;

      _classCallCheck(this, CustomMountNodeExample);

      for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      return _ret2 = (_temp2 = (_this2 = _possibleConstructorReturn(this, (_ref5 = CustomMountNodeExample.__proto__ || Object.getPrototypeOf(CustomMountNodeExample)).call.apply(_ref5, [this].concat(args))), _this2), _this2.state = { mounted: false }, _temp2), _possibleConstructorReturn(_this2, _ret2);
    }

    _createClass(CustomMountNodeExample, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        this.mountNode = document.createElement('div');
        this.mountNode.classList.add('custom-mount-node');
        if (document.body) {
          document.body.append(this.mountNode);
        }
        this.setState({ mounted: true });
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        var _this3 = this;

        setTimeout(function () {
          if (_this3.mountNode.parentNode) {
            _this3.mountNode.parentNode.removeChild(_this3.mountNode);
          }
        }, 10);
      }
    }, {
      key: 'render',
      value: function render() {
        var _this4 = this;

        if (!this.state.mounted) {
          return false;
        }
        return React.createElement(
          Centered,
          null,
          React.createElement(
            ModalStateContainer,
            { isInitiallyOpen: true },
            function (_ref6) {
              var open = _ref6.open,
                  close = _ref6.close,
                  isOpen = _ref6.isOpen;
              return React.createElement(
                React.Fragment,
                null,
                React.createElement(
                  _button.Button,
                  { onClick: open },
                  'Open Modal'
                ),
                React.createElement(
                  _index.Modal,
                  {
                    onClose: close,
                    isOpen: isOpen,
                    mountNode: _this4.mountNode
                  },
                  React.createElement(
                    _index.ModalHeader,
                    null,
                    'Hello world'
                  ),
                  React.createElement(
                    _index.ModalBody,
                    null,
                    React.createElement(
                      'p',
                      null,
                      'If you inspect the DOM, you will see that this modal was mounted into a custom node on the page, instead of as a child of document.body.'
                    ),
                    React.createElement(
                      'p',
                      null,
                      'This can be useful for applications which have a complicated DOM structure and need more control over mount points.'
                    )
                  ),
                  React.createElement(
                    _index.ModalFooter,
                    null,
                    React.createElement(
                      _index.ModalButton,
                      { onClick: close },
                      'Okay'
                    )
                  )
                )
              );
            }
          )
        );
      }
    }]);

    return CustomMountNodeExample;
  }(React.Component);

  return React.createElement(CustomMountNodeExample, null);
}), _defineProperty(_examples$SIMPLE_EXAM, _examplesList2.default.STYLE_OVERRIDES, function Story1() {
  return React.createElement(
    Centered,
    null,
    React.createElement(
      ModalStateContainer,
      { isInitiallyOpen: true },
      function (_ref7) {
        var open = _ref7.open,
            close = _ref7.close,
            isOpen = _ref7.isOpen;
        return React.createElement(
          React.Fragment,
          null,
          React.createElement(
            _button.Button,
            { onClick: open },
            'Open Modal'
          ),
          React.createElement(
            _index.Modal,
            {
              overrides: {
                Backdrop: {
                  style: {
                    backgroundColor: 'rgba(43, 116, 226, 0.2)'
                  }
                },
                Dialog: {
                  style: {
                    backgroundColor: 'rgb(43, 116, 226)',
                    borderRadius: '0px'
                  }
                },
                Close: {
                  style: {
                    color: 'white',
                    ':hover': {
                      color: 'white',
                      opacity: 0.2
                    }
                  }
                }
              },
              onClose: close,
              isOpen: isOpen
            },
            React.createElement(
              _index.ModalHeader,
              { $style: { color: 'white', fontSize: '48px' } },
              'Hello world'
            ),
            React.createElement(
              _index.ModalBody,
              { $style: { color: 'white', fontStyle: 'italic' } },
              'Proin ut dui sed metus pharetra hend rerit vel non mi. Nulla ornare faucibus ex, non facilisis nisl. Maecenas aliquet mauris ut tempus.'
            )
          )
        );
      }
    )
  );
}), _examples$SIMPLE_EXAM);