'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _overrides = require('../helpers/overrides');

var _constants = require('./constants');

var _utils = require('./utils');

var _styledComponents = require('./styled-components');

var _closeIcon = require('./close-icon');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */

/* global document */


var Modal = function (_React$Component) {
  _inherits(Modal, _React$Component);

  function Modal() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Modal);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Modal.__proto__ || Object.getPrototypeOf(Modal)).call.apply(_ref, [this].concat(args))), _this), _this.lastFocus = null, _this._refs = {}, _this.state = {
      isVisible: false,
      mounted: false
    }, _this.onDocumentKeyPress = function (event) {
      if (event.key !== 'Escape') {
        return;
      }

      // Ignore events that have been `event.preventDefault()` marked.
      if (event.defaultPrevented) {
        return;
      }

      if (!_this.props.closeable) {
        return;
      }

      _this.close(_constants.CLOSE_SOURCE.escape);
    }, _this.onBackdropClick = function () {
      if (!_this.props.closeable) {
        return;
      }
      _this.close(_constants.CLOSE_SOURCE.backdrop);
    }, _this.onCloseClick = function () {
      _this.close(_constants.CLOSE_SOURCE.closeButton);
    }, _this.captureLastFocus = function () {
      _this.lastFocus = (0, _utils.ownerDocument)(_this.getMountNode()).activeElement;
    }, _this.restoreLastFocus = function () {
      if (_this.lastFocus) {
        // Not all elements in IE11 can focus
        if (_this.lastFocus.focus) {
          _this.lastFocus.focus();
        }
        _this.lastFocus = null;
      }
    }, _this.autoFocus = function () {
      if (!_this.props.autofocus) {
        return;
      }
      var dialog = _this.getRef('Dialog').current;
      if (!dialog) {
        return;
      }
      dialog.focus();
    }, _this.animateOutComplete = function () {
      _this.setState({
        isVisible: false
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Modal, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.setState({ mounted: true });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.removeDomEvents();
      this.clearTimers();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      var isOpen = this.props.isOpen;

      if (
      // If isOpen is changing *or* we just mounted and modal should be open
      isOpen !== prevProps.isOpen || isOpen && this.state.mounted && !prevState.mounted) {
        if (isOpen) {
          this.open();
        } else {
          this.close();
        }
      }
    }
  }, {
    key: 'addDomEvents',
    value: function addDomEvents() {
      if (typeof document !== 'undefined') {
        document.addEventListener('keyup', this.onDocumentKeyPress);
      }
    }
  }, {
    key: 'removeDomEvents',
    value: function removeDomEvents() {
      if (typeof document !== 'undefined') {
        document.removeEventListener('keyup', this.onDocumentKeyPress);
      }
    }
  }, {
    key: 'clearTimers',
    value: function clearTimers() {
      if (this.animateOutTimer) {
        clearTimeout(this.animateOutTimer);
      }
      if (this.animateStartTimer) {
        // eslint-disable-next-line cup/no-undef
        cancelAnimationFrame(this.animateStartTimer);
      }
    }
  }, {
    key: 'open',
    value: function open() {
      var _this2 = this;

      // Store last focused item (we'll return focus after closing for a11y)
      this.captureLastFocus();
      this.autoFocus();

      // Sometimes scroll starts past zero, possibly due to animation
      // Reset scroll to 0 (other libraries do this as well)
      var rootRef = this.getRef('Root').current;
      if (rootRef) {
        rootRef.scrollTop = 0;
      }

      // Clear any existing timers (like previous animateOutTimer)
      this.clearTimers();
      this.addDomEvents();

      // eslint-disable-next-line cup/no-undef
      this.animateStartTimer = requestAnimationFrame(function () {
        _this2.setState({ isVisible: true });
      });
    }
  }, {
    key: 'close',
    value: function close(source) {
      // If there's no source, it just means the isOpen prop changed. No need to call onClose.
      if (this.props.onClose && source) {
        this.props.onClose({
          closeSource: source
        });
      }
      this.removeDomEvents();
      this.animateOutTimer = setTimeout(this.animateOutComplete, 500);
      this.restoreLastFocus();
    }
  }, {
    key: 'getSharedProps',
    value: function getSharedProps() {
      var _props = this.props,
          animate = _props.animate,
          isOpen = _props.isOpen,
          size = _props.size,
          role = _props.role,
          closeable = _props.closeable;

      return {
        $animate: animate,
        $isVisible: this.state.isVisible,
        $isOpen: Boolean(isOpen),
        $size: size,
        $role: role,
        $closeable: Boolean(closeable)
      };
    }
  }, {
    key: 'getMountNode',
    value: function getMountNode() {
      var mountNode = this.props.mountNode;

      if (mountNode) {
        return mountNode;
      }
      // Flow thinks body could be null (cast through any)
      // eslint-disable-next-line flowtype/no-weak-types
      return document.body;
    }
  }, {
    key: 'getChildren',
    value: function getChildren() {
      var children = this.props.children;

      return typeof children === 'function' ? children() : children;
    }
  }, {
    key: 'getRef',
    value: function getRef(component) {
      var overrideProps = (0, _overrides.getOverrideProps)(this.props.overrides.Dialog);
      var overrideRef = overrideProps.$ref;
      if (overrideRef) {
        return overrideRef;
      }
      if (!this._refs[component]) {
        this._refs[component] = React.createRef();
      }
      return this._refs[component];
    }
  }, {
    key: 'renderModal',
    value: function renderModal() {
      var _props2 = this.props,
          _props2$overrides = _props2.overrides,
          overrides = _props2$overrides === undefined ? {} : _props2$overrides,
          closeable = _props2.closeable,
          role = _props2.role;
      var RootOverride = overrides.Root,
          DialogOverride = overrides.Dialog,
          DialogContainerOverride = overrides.DialogContainer,
          BackdropOverride = overrides.Backdrop,
          CloseOverride = overrides.Close;


      var Root = (0, _overrides.getOverride)(RootOverride) || _styledComponents.Root;
      var Backdrop = (0, _overrides.getOverride)(BackdropOverride) || _styledComponents.Backdrop;
      var DialogContainer = (0, _overrides.getOverride)(DialogContainerOverride) || _styledComponents.DialogContainer;
      var Dialog = (0, _overrides.getOverride)(DialogOverride) || _styledComponents.Dialog;
      var Close = (0, _overrides.getOverride)(CloseOverride) || _styledComponents.Close;

      var sharedProps = this.getSharedProps();
      var children = this.getChildren();

      return React.createElement(
        Root,
        _extends({
          $ref: this.getRef('Root')
        }, sharedProps, (0, _overrides.getOverrideProps)(RootOverride)),
        React.createElement(Backdrop, _extends({
          onClick: this.onBackdropClick
        }, sharedProps, (0, _overrides.getOverrideProps)(BackdropOverride))),
        React.createElement(
          DialogContainer,
          _extends({}, sharedProps, (0, _overrides.getOverrideProps)(DialogContainerOverride)),
          React.createElement(
            Dialog,
            _extends({
              tabIndex: '-1',
              'aria-modal':
              // aria-modal replaces the need to apply aria-hidden="true" to all other page
              // content underneath the modal.
              // https://www.w3.org/TR/wai-aria-practices-1.1/examples/dialog-modal/dialog.html
              'true',
              role: role,
              $ref: this.getRef('Dialog')
            }, sharedProps, (0, _overrides.getOverrideProps)(DialogOverride)),
            closeable ? React.createElement(
              Close,
              _extends({
                'aria-label': 'Close',
                onClick: this.onCloseClick
              }, sharedProps, (0, _overrides.getOverrideProps)(CloseOverride)),
              React.createElement(_closeIcon.CloseIcon, null)
            ) : null,
            children
          )
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      // Only render modal on the browser (portals aren't supported server-side)
      if (!this.state.mounted) {
        return null;
      }
      // Only render the modal if its isOpen is passed, or isVisible is true (still animating)
      if (!this.props.isOpen && !this.state.isVisible) {
        return null;
      }
      var mountNode = this.getMountNode();
      if (!mountNode) {
        return null;
      }
      return _reactDom2.default.createPortal(this.renderModal(), mountNode);
    }
  }]);

  return Modal;
}(React.Component);

Modal.defaultProps = {
  animate: true,
  autofocus: true,
  closeable: true,
  isOpen: false,
  overrides: {},
  role: _constants.ROLE.dialog,
  size: _constants.SIZE.default
};
exports.default = Modal;