'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.examples = exports.suite = undefined;

var _examples$STATEFUL_PA;

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _statefulPagination = require('./stateful-pagination');

var _statefulPagination2 = _interopRequireDefault(_statefulPagination);

var _pagination = require('./pagination');

var _pagination2 = _interopRequireDefault(_pagination);

var _button = require('../button');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; } /*
                                                                                                                                                                                                                  Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                  
                                                                                                                                                                                                                  This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                  LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                  */


var suite = exports.suite = 'Pagination Test Suite';
var examples = exports.examples = {
  STATEFUL_PAGINATION: 'Stateful Pagination',
  STATELESS_PAGINATION: 'Stateless Pagination',
  PAGINATION_OVERRIDE: 'With Overrides'
};

exports.default = (_examples$STATEFUL_PA = {}, _defineProperty(_examples$STATEFUL_PA, examples.STATEFUL_PAGINATION, function Story1() {
  return React.createElement(_statefulPagination2.default, { numPages: 10 });
}), _defineProperty(_examples$STATEFUL_PA, examples.STATELESS_PAGINATION, function Story2() {
  return React.createElement(_pagination2.default, { numPages: 18, currentPage: 4 });
}), _defineProperty(_examples$STATEFUL_PA, examples.PAGINATION_OVERRIDE, function Story2() {
  return React.createElement(_statefulPagination2.default, {
    numPages: 10,
    labels: {
      prevButton: 'Back',
      nextButton: 'Forward',
      preposition: 'out of'
    },
    overrides: {
      NextButton: {
        props: {
          kind: _button.KIND.secondary
        }
      },
      PrevButton: {
        props: {
          kind: _button.KIND.secondary
        }
      }
    }
  });
}), _examples$STATEFUL_PA);