'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DropdownButton = exports.DropdownMenu = exports.DropdownContainer = exports.MaxLabel = exports.Root = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /*
                                                                                                                                                                                                                                                                  Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                  
                                                                                                                                                                                                                                                                  This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                  LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                  */


var _styles = require('../styles');

var _menu = require('../menu');

var _button = require('../button');

var Root = exports.Root = (0, _styles.styled)('div', {
  display: 'flex',
  alignItems: 'center'
});

var MaxLabel = exports.MaxLabel = (0, _styles.styled)('span', function (_ref) {
  var $theme = _ref.$theme;
  return _extends({}, $theme.typography.font300, {
    marginLeft: $theme.sizing.scale300,
    marginRight: $theme.sizing.scale600
  });
});

var DropdownContainer = exports.DropdownContainer = (0, _styles.styled)('div', function (_ref2) {
  var $theme = _ref2.$theme;
  return {
    position: 'relative',
    marginLeft: $theme.sizing.scale600,
    marginRight: $theme.sizing.scale300
  };
});

var DropdownMenu = exports.DropdownMenu = (0, _styles.styled)(_menu.StyledList, function (_ref3) {
  var $theme = _ref3.$theme;
  return {
    position: 'absolute',
    overflow: 'auto',
    maxHeight: '200px',
    top: 'auto',
    marginTop: $theme.sizing.scale300,
    left: 0,
    right: 0
  };
});

var DropdownButton = exports.DropdownButton = (0, _styles.styled)(_button.StyledBaseButton, function (_ref4) {
  var $theme = _ref4.$theme;
  return {
    color: $theme.colors.black,
    minWidth: 'calc(' + $theme.sizing.scale1600 + ' + ' + $theme.sizing.scale400 + ')'
  };
});