'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _constants = require('./constants');

var _defaultProps = require('./default-props');

var _defaultProps2 = _interopRequireDefault(_defaultProps);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */


var defaultStateReducer = function defaultStateReducer(type, nextState) {
  return nextState;
};

var StatefulContainer = function (_React$Component) {
  _inherits(StatefulContainer, _React$Component);

  function StatefulContainer() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, StatefulContainer);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = StatefulContainer.__proto__ || Object.getPrototypeOf(StatefulContainer)).call.apply(_ref, [this].concat(args))), _this), _this.state = _extends({
      isOpen: false
    }, _this.props.initialState), _this.onBlur = function () {
      _this.close();
    }, _this.onClick = function () {
      if (_this.state.isOpen) {
        _this.close();
      } else {
        _this.open();
      }
    }, _this.onClickOutside = function () {
      _this.close();
    }, _this.onEsc = function () {
      _this.close();
    }, _this.onFocus = function () {
      _this.open();
    }, _this.onMouseEnter = function () {
      _this.open();
    }, _this.onMouseLeave = function () {
      _this.close();
    }, _this.onContentClose = function () {
      _this.close();
    }, _this.renderContent = function () {
      var content = _this.props.content;

      if (typeof content === 'function') {
        return content({ close: _this.onContentClose });
      }
      return content;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(StatefulContainer, [{
    key: 'open',
    value: function open() {
      this.internalSetState(_constants.STATE_CHANGE_TYPE.open, {
        isOpen: true
      });
    }
  }, {
    key: 'close',
    value: function close() {
      this.internalSetState(_constants.STATE_CHANGE_TYPE.close, {
        isOpen: false
      });
    }
  }, {
    key: 'internalSetState',
    value: function internalSetState(type, changes) {
      var stateReducer = this.props.stateReducer;

      if (typeof stateReducer !== 'function') {
        this.setState(changes);
        return;
      }
      this.setState(function (prevState) {
        return stateReducer(type, changes, prevState);
      });
    }

    /**
     * If user passed a content render prop, we want to give them a
     * callback to close the Popover. This is useful in any case where
     * a dev wants to manually close the popover based on some action.
     *
     * One simple example is a Popover with a "Dismiss" button in it:
     * <StatefulPopover content={({close}) => <button onClick={close}>Dismiss</button>}>
     *  Click me
     * </StatefulPopover>
     */

  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          accessibilityType = _props.accessibilityType,
          dismissOnClickOutside = _props.dismissOnClickOutside,
          dismissOnEsc = _props.dismissOnEsc,
          overrides = _props.overrides,
          onMouseEnterDelay = _props.onMouseEnterDelay,
          onMouseLeaveDelay = _props.onMouseLeaveDelay,
          placement = _props.placement,
          showArrow = _props.showArrow,
          triggerType = _props.triggerType;


      var popoverProps = {
        accessibilityType: accessibilityType,
        isOpen: this.state.isOpen,
        overrides: overrides,
        content: this.renderContent,
        onMouseEnterDelay: onMouseEnterDelay,
        onMouseLeaveDelay: onMouseLeaveDelay,
        placement: placement,
        showArrow: showArrow,
        triggerType: triggerType
      };

      if (dismissOnClickOutside) {
        popoverProps.onClickOutside = this.onClickOutside;
      }
      if (dismissOnEsc) {
        popoverProps.onEsc = this.onEsc;
      }
      if (triggerType === _constants.TRIGGER_TYPE.hover) {
        popoverProps.onBlur = this.onBlur;
        popoverProps.onFocus = this.onFocus;
        popoverProps.onMouseEnter = this.onMouseEnter;
        popoverProps.onMouseLeave = this.onMouseLeave;
      } else {
        popoverProps.onClick = this.onClick;
      }

      return this.props.children(popoverProps);
    }
  }]);

  return StatefulContainer;
}(React.Component);

StatefulContainer.defaultProps = _extends({}, _defaultProps2.default, {
  dismissOnClickOutside: true,
  dismissOnEsc: true,
  stateReducer: defaultStateReducer
});
exports.default = StatefulContainer;