'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _overrides = require('../helpers/overrides');

var _styledComponents = require('./styled-components');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */


var ProgressBar = function (_React$Component) {
  _inherits(ProgressBar, _React$Component);

  function ProgressBar() {
    _classCallCheck(this, ProgressBar);

    return _possibleConstructorReturn(this, (ProgressBar.__proto__ || Object.getPrototypeOf(ProgressBar)).apply(this, arguments));
  }

  _createClass(ProgressBar, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          _props$overrides = _props.overrides,
          overrides = _props$overrides === undefined ? {} : _props$overrides,
          getProgressLabel = _props.getProgressLabel,
          value = _props.value,
          successValue = _props.successValue,
          showLabel = _props.showLabel;

      var _getOverrides = (0, _overrides.getOverrides)(overrides.Root, _styledComponents.Root),
          _getOverrides2 = _slicedToArray(_getOverrides, 2),
          Root = _getOverrides2[0],
          rootProps = _getOverrides2[1];

      var _getOverrides3 = (0, _overrides.getOverrides)(overrides.Bar, _styledComponents.Bar),
          _getOverrides4 = _slicedToArray(_getOverrides3, 2),
          Bar = _getOverrides4[0],
          barProps = _getOverrides4[1];

      var _getOverrides5 = (0, _overrides.getOverrides)(overrides.BarProgress, _styledComponents.BarProgress),
          _getOverrides6 = _slicedToArray(_getOverrides5, 2),
          BarProgress = _getOverrides6[0],
          barProgressProps = _getOverrides6[1];

      var _getOverrides7 = (0, _overrides.getOverrides)(overrides.Label, _styledComponents.Label),
          _getOverrides8 = _slicedToArray(_getOverrides7, 2),
          Label = _getOverrides8[0],
          labelProps = _getOverrides8[1];

      var sharedProps = {
        $value: value,
        $successValue: successValue
      };
      return React.createElement(
        Root,
        _extends({ role: 'progressbar' }, sharedProps, rootProps),
        React.createElement(
          Bar,
          _extends({}, sharedProps, barProps),
          React.createElement(BarProgress, _extends({}, sharedProps, barProgressProps))
        ),
        showLabel && React.createElement(
          Label,
          _extends({}, sharedProps, labelProps),
          getProgressLabel(value, successValue)
        )
      );
    }
  }]);

  return ProgressBar;
}(React.Component);

ProgressBar.defaultProps = {
  getProgressLabel: function getProgressLabel(value, successValue) {
    return Math.round(value / successValue * 100) + '% Loaded';
  },
  successValue: 100,
  value: 0,
  overrides: {},
  showLabel: true
};
exports.default = ProgressBar;