'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Label = exports.BarProgress = exports.Bar = exports.Root = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /*
                                                                                                                                                                                                                                                                  Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                  
                                                                                                                                                                                                                                                                  This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                  LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                  */


var _index = require('../styles/index');

var Root = exports.Root = (0, _index.styled)('div', function (props) {
  return {
    width: '100%'
  };
});

var Bar = exports.Bar = (0, _index.styled)('div', function (props) {
  var $theme = props.$theme;
  var colors = $theme.colors,
      sizing = $theme.sizing,
      borders = $theme.borders;

  return {
    marginLeft: sizing.scale500,
    marginRight: sizing.scale500,
    marginTop: sizing.scale500,
    marginBottom: sizing.scale500,
    borderRadius: borders.useRoundedCorners ? sizing.scale0 : '0',
    backgroundColor: colors.mono400,
    height: '4px'
  };
});

var BarProgress = exports.BarProgress = (0, _index.styled)('div', function (props) {
  var $theme = props.$theme,
      $value = props.$value,
      $successValue = props.$successValue;
  var colors = $theme.colors,
      sizing = $theme.sizing,
      borders = $theme.borders;

  var width = $value / $successValue * 100 + '%';
  return {
    borderRadius: borders.useRoundedCorners ? sizing.scale0 : '0',
    backgroundColor: colors.primary400,
    width: width,
    transition: 'width 0.5s',
    height: '100%'
  };
});

var Label = exports.Label = (0, _index.styled)('div', function (props) {
  return _extends({
    textAlign: 'center'
  }, props.$theme.typography.font250, {
    color: props.$theme.colors.mono700
  });
});