'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.tests = exports.suite = undefined;

var _tests$SIMPLE_EXAMPLE;

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _styletronReact = require('styletron-react');

var _index = require('./index');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; } /*
                                                                                                                                                                                                                  Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                  
                                                                                                                                                                                                                  This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                  LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                  */


/* eslint-disable react/display-name*/


var suite = exports.suite = 'Radio Group Test Suite';
var tests = exports.tests = {
  SIMPLE_EXAMPLE: 'Radio Group example',
  WITH_ERROR: 'RadioGroup with an error',
  DISABLED: 'RadioGroup disabled',
  HORIZONTAL_ALIGN: 'RadioGroup horizontal',
  VERTICAL_ALIGN: 'RadioGroup vertical',
  STYLES_OVERRIDES: 'RadioGroup with style overrides',
  COMPONENTS_OVERRIDES: 'RadioGroup with override components',
  EXTRA_PROPS: 'RadioGroup with extra props'
};

exports.default = (_tests$SIMPLE_EXAMPLE = {}, _defineProperty(_tests$SIMPLE_EXAMPLE, tests.SIMPLE_EXAMPLE, function () {
  return React.createElement(
    _index.StatefulRadioGroup,
    { initialState: { value: '2' } },
    React.createElement(
      _index.StyledRadio,
      { value: '1' },
      'First'
    ),
    React.createElement(
      _index.StyledRadio,
      { value: '2' },
      'Second'
    ),
    React.createElement(
      _index.StyledRadio,
      { value: '3' },
      'Third'
    )
  );
}), _defineProperty(_tests$SIMPLE_EXAMPLE, tests.HORIZONTAL_ALIGN, function () {
  return React.createElement(
    _index.StatefulRadioGroup,
    { align: 'horizontal', initialState: { value: '3' } },
    React.createElement(
      _index.StyledRadio,
      { value: '1' },
      'First'
    ),
    React.createElement(
      _index.StyledRadio,
      { value: '2' },
      'Second'
    ),
    React.createElement(
      _index.StyledRadio,
      { value: '3' },
      'Third'
    )
  );
}), _defineProperty(_tests$SIMPLE_EXAMPLE, tests.COMPONENTS_OVERRIDES, function () {
  var overrides = {
    Label: function Label(props) {
      return React.createElement(
        'div',
        null,
        'Custom Label for value ',
        props.$value
      );
    }
  };
  return React.createElement(
    _index.StatefulRadioGroup,
    { overrides: overrides, initialState: { value: '3' } },
    React.createElement(
      _index.StyledRadio,
      { value: '1' },
      'First'
    ),
    React.createElement(
      _index.StyledRadio,
      { value: '2' },
      'Second'
    ),
    React.createElement(
      _index.StyledRadio,
      { value: '3' },
      'Third'
    )
  );
}), _defineProperty(_tests$SIMPLE_EXAMPLE, tests.STYLES_OVERRIDES, function () {
  var overrides = {
    RadioMark: {
      style: { borderColor: 'red' }
    },
    Label: (0, _styletronReact.withStyle)(_index.StyledLabel, function () {
      return {
        color: 'orange',
        fontSize: '25px'
      };
    })
  };
  return React.createElement(
    _index.StatefulRadioGroup,
    { overrides: overrides, initialState: { value: '3' } },
    React.createElement(
      _index.StyledRadio,
      { value: '1' },
      'First'
    ),
    React.createElement(
      _index.StyledRadio,
      { value: '2' },
      'Second'
    ),
    React.createElement(
      _index.StyledRadio,
      { value: '3' },
      'Third'
    )
  );
}), _defineProperty(_tests$SIMPLE_EXAMPLE, tests.WITH_ERROR, function () {
  return React.createElement(
    _index.StatefulRadioGroup,
    { isError: true, initialState: { value: '3' } },
    React.createElement(
      _index.StyledRadio,
      { value: '1' },
      'First'
    ),
    React.createElement(
      _index.StyledRadio,
      { value: '2' },
      'Second'
    ),
    React.createElement(
      _index.StyledRadio,
      { value: '3' },
      'Third'
    )
  );
}), _tests$SIMPLE_EXAMPLE);