'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('./styled-components');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */


var StatelessRadioGroup = function (_React$Component) {
  _inherits(StatelessRadioGroup, _React$Component);

  function StatelessRadioGroup() {
    _classCallCheck(this, StatelessRadioGroup);

    return _possibleConstructorReturn(this, (StatelessRadioGroup.__proto__ || Object.getPrototypeOf(StatelessRadioGroup)).apply(this, arguments));
  }

  _createClass(StatelessRadioGroup, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          name = _props.name,
          children = _props.children,
          labelPlacement = _props.labelPlacement,
          isError = _props.isError,
          disabled = _props.disabled,
          align = _props.align,
          required = _props.required,
          _props$overrides = _props.overrides,
          overrides = _props$overrides === undefined ? {} : _props$overrides;

      var events = {
        onChange: this.props.onChange,
        onMouseEnter: this.props.onMouseEnter,
        onMouseLeave: this.props.onMouseLeave,
        onFocus: this.props.onFocus,
        onBlur: this.props.onBlur
      };
      var sharedProps = {
        $isError: isError,
        $required: required,
        $disabled: disabled
      };
      var _overrides$Root = overrides.Root,
          Root = _overrides$Root === undefined ? _styledComponents.Root : _overrides$Root,
          _overrides$RadioMark = overrides.RadioMark,
          RadioMark = _overrides$RadioMark === undefined ? _styledComponents.RadioMark : _overrides$RadioMark,
          _overrides$Label = overrides.Label,
          Label = _overrides$Label === undefined ? _styledComponents.Label : _overrides$Label,
          _overrides$Input = overrides.Input,
          Input = _overrides$Input === undefined ? _styledComponents.Input : _overrides$Input;

      var childrenProps = _extends({
        name: name,
        isError: isError,
        disabled: disabled,
        required: required,
        labelPlacement: labelPlacement,
        type: 'radio',
        overrides: { Root: Root, Checkmark: RadioMark, Label: Label, Input: Input }
      }, sharedProps, events);
      return _react2.default.createElement(
        _styledComponents.RadioGroupRoot,
        _extends({ $align: align }, sharedProps),
        _react2.default.Children.map(children, function (child) {
          if (!_react2.default.isValidElement(child)) {
            return null;
          }
          return _react2.default.cloneElement(child, _extends({}, childrenProps, {
            checked: _this2.props.value === child.props.value,
            disabled: _this2.props.disabled || child.props.disabled
          }));
        })
      );
    }
  }]);

  return StatelessRadioGroup;
}(_react2.default.Component);

StatelessRadioGroup.defaultProps = {
  name: '',
  value: '',
  disabled: false,
  autoFocus: false,
  labelPlacement: 'right',
  align: 'vertical',
  isError: false,
  required: false,
  onChange: function onChange() {},
  onMouseEnter: function onMouseEnter() {},
  onMouseLeave: function onMouseLeave() {},
  onFocus: function onFocus() {},
  onBlur: function onBlur() {}
};
exports.default = StatelessRadioGroup;