'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.tests = exports.suite = undefined;

var _tests$SIMPLE_EXAMPLE;

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _styles = require('../styles');

var _index = require('./index');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; } /*
                                                                                                                                                                                                                  Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                  
                                                                                                                                                                                                                  This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                  LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                  */


var suite = exports.suite = 'Spinner Test Suite';
var tests = exports.tests = {
  SIMPLE_EXAMPLE: 'Spinner component',
  STYLE_PROPS_OVERRIDES: 'Spinner style and props overrides'
};

var Centered = (0, _styles.styled)('div', {
  position: 'relative',
  display: 'flex',
  flexDirection: 'row',
  justifyContent: 'center',
  alignItems: 'center',
  height: '90vh',
  lineHeight: 1.5
});

var Spacing = (0, _styles.styled)('span', {
  margin: '10px'
});

exports.default = (_tests$SIMPLE_EXAMPLE = {}, _defineProperty(_tests$SIMPLE_EXAMPLE, tests.SIMPLE_EXAMPLE, function Story1() {
  return React.createElement(
    Centered,
    null,
    React.createElement(
      Spacing,
      null,
      React.createElement(_index.Spinner, { size: 22 })
    ),
    React.createElement(
      Spacing,
      null,
      React.createElement(_index.Spinner, null)
    ),
    React.createElement(
      Spacing,
      null,
      React.createElement(_index.Spinner, { size: 88 })
    )
  );
}), _defineProperty(_tests$SIMPLE_EXAMPLE, tests.STYLE_PROPS_OVERRIDES, function Story3() {
  return React.createElement(
    Centered,
    null,
    React.createElement(_index.Spinner, {
      overrides: {
        Svg: {
          props: {
            'data-label': 'data-label'
          },
          style: function style(_ref) {
            var $theme = _ref.$theme;
            return {
              borderRadius: '50%',
              backgroundColor: $theme.colors.primary50
            };
          }
        }
      }
    })
  );
}), _tests$SIMPLE_EXAMPLE);