'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Toaster = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _overrides = require('../helpers/overrides');

var _constants = require('./constants');

var _styledComponents = require('./styled-components');

var _toast = require('./toast');

var _toast2 = _interopRequireDefault(_toast);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var toasterRef = null;

function toasterRefCallback(ref) {
  toasterRef = ref;
}

var ToasterComponent = function (_React$Component) {
  _inherits(ToasterComponent, _React$Component);

  function ToasterComponent() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ToasterComponent);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ToasterComponent.__proto__ || Object.getPrototypeOf(ToasterComponent)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      isMounted: false,
      toasts: []
    }, _this.dismissHandlers = {}, _this.toastId = 0, _this.getToastProps = function (props) {
      var key = props.key || 'toast-' + _this.toastId++;
      return _extends({}, props, { key: key });
    }, _this.show = function () {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var toastProps = _this.getToastProps(props);
      _this.setState(function (_ref2) {
        var toasts = _ref2.toasts;

        toasts.push(toastProps);
        return { toasts: toasts };
      });
      return toastProps.key;
    }, _this.update = function (key, props) {
      _this.setState(function (_ref3) {
        var toasts = _ref3.toasts;

        toasts.forEach(function (t, index, arr) {
          if (t.key === key) {
            arr[index] = _extends({}, t, _this.getToastProps(props), { key: key });
          }
        });
        return {
          toasts: toasts
        };
      });
    }, _this.dismiss = function (key) {
      if (_this.dismissHandlers[key]) {
        _this.dismissHandlers[key]();
      }
    }, _this.clearAll = function () {
      Object.keys(_this.dismissHandlers).forEach(function (key) {
        _this.dismissHandlers[key]();
      });
    }, _this.clear = function (key) {
      key === undefined ? _this.clearAll() : _this.dismiss(key);
    }, _this.internalOnClose = function (key) {
      delete _this.dismissHandlers[key];
      _this.setState(function (_ref4) {
        var toasts = _ref4.toasts;
        return {
          toasts: toasts.filter(function (t) {
            return !(t.key === key);
          })
        };
      });
    }, _this.getOnCloseHandler = function (key, onClose) {
      return function () {
        _this.internalOnClose(key);
        typeof onClose === 'function' && onClose();
      };
    }, _this.renderToast = function (toastProps) {
      var onClose = toastProps.onClose,
          children = toastProps.children,
          key = toastProps.key,
          rest = _objectWithoutProperties(toastProps, ['onClose', 'children', 'key']);

      var _this$props$overrides = _this.props.overrides,
          BodyOverride = _this$props$overrides.ToastBody,
          CloseIconOverride = _this$props$overrides.ToastCloseIcon;

      var globalToastOverrides = (0, _overrides.mergeOverrides)({ Body: _styledComponents.Body, CloseIcon: _styledComponents.CloseIconSvg },
      // $FlowFixMe
      { Body: BodyOverride, CloseIcon: CloseIconOverride });
      var toastOverrides = (0, _overrides.mergeOverrides)(globalToastOverrides, toastProps.overrides);

      return React.createElement(
        _toast2.default,
        _extends({}, rest, {
          overrides: toastOverrides,
          key: key,
          onClose: _this.getOnCloseHandler(key, onClose)
        }),
        function (_ref5) {
          var dismiss = _ref5.dismiss;

          _this.dismissHandlers[key] = dismiss;
          return children;
        }
      );
    }, _this.getSharedProps = function () {
      var placement = _this.props.placement;

      return {
        $placement: placement
      };
    }, _this.render = function () {
      var sharedProps = _this.getSharedProps();

      var RootOverride = _this.props.overrides.Root;
      // $FlowFixMe

      var _getOverrides = (0, _overrides.getOverrides)(RootOverride, _styledComponents.Root),
          _getOverrides2 = _slicedToArray(_getOverrides, 2),
          Root = _getOverrides2[0],
          rootProps = _getOverrides2[1];

      var toastsLength = _this.state.toasts.length;
      var toastsToRender = [];
      // render the toasts from the newest at the start
      // to the oldest at the end
      // eslint-disable-next-line for-direction
      for (var i = toastsLength - 1; i >= 0; i--) {
        toastsToRender.push(_this.renderToast(_this.state.toasts[i]));
      }

      var root = React.createElement(
        Root,
        _extends({}, sharedProps, rootProps),
        toastsToRender
      );
      if (_this.state.isMounted) {
        // Only render on the browser (portals aren't supported server-side)
        if (_this.props.usePortal) {
          if (typeof document !== 'undefined') {
            return _reactDom2.default.createPortal(root,
            // $FlowFixMe
            document.body);
          }
        } else {
          return root;
        }
      }
      return null;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ToasterComponent, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.setState({ isMounted: true });
    }
  }]);

  return ToasterComponent;
}(React.Component);

ToasterComponent.defaultProps = {
  placement: _constants.PLACEMENT.top,
  usePortal: true,
  overrides: {}
};


var toaster = {
  getRef: function getRef() {
    return toasterRef;
  },
  create: function create(props) {
    return React.createElement(ToasterComponent, _extends({}, props, { ref: toasterRefCallback }));
  },
  show: function show(children) {
    var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    // toasts can not be added until Toaster is mounted
    // no SSR for the `toaster.show()`
    var toasterInstance = this.getRef();
    if (toasterInstance) {
      return toasterInstance.show(_extends({ children: children }, props));
    } else if (process.env.NODE_ENV !== 'production') {
      throw new Error('Can not add any toasts until Toaster is mounted!');
    }
  },
  info: function info(children) {
    var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    return this.show(children, _extends({}, props, { kind: _constants.KIND.info }));
  },
  positive: function positive(children) {
    var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    return this.show(children, _extends({}, props, { kind: _constants.KIND.positive }));
  },
  warning: function warning(children) {
    var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    return this.show(children, _extends({}, props, { kind: _constants.KIND.warning }));
  },
  negative: function negative(children) {
    var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    return this.show(children, _extends({}, props, { kind: _constants.KIND.negative }));
  },
  update: function update(key, props) {
    var toasterInstance = this.getRef();
    if (toasterInstance) {
      toasterInstance.update(key, props);
    } else if (process.env.NODE_ENV !== 'production') {
      // eslint-disable-next-line no-console
      console.error('No Toaster is mounted yet.');
    }
  },
  clear: function clear(key) {
    var toasterInstance = this.getRef();
    if (toasterInstance) {
      toasterInstance.clear(key);
    } else if (process.env.NODE_ENV !== 'production') {
      // eslint-disable-next-line no-console
      console.error('No Toaster is mounted yet.');
    }
  }
};

var Toaster = exports.Toaster = ToasterComponent;
exports.default = toaster;