'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /*
                                                                                                                                                                                                                                                                  Copyright (c) 2018 Uber Technologies, Inc.
                                                                                                                                                                                                                                                                  
                                                                                                                                                                                                                                                                  This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                  LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                  */

/*global module */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('./styles');

var _react3 = require('@storybook/react');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Root = (0, _styles.styled)('div', function (_ref) {
  var $theme = _ref.$theme;
  return {
    padding: $theme.sizing.scale800,
    width: '600px',
    maxWidth: '500px'
  };
});

var P = (0, _styles.styled)('p', function (_ref2) {
  var $theme = _ref2.$theme;
  return _extends({}, $theme.typography.font400);
});

var Anchor = (0, _styles.styled)('a', function (_ref3) {
  var $theme = _ref3.$theme;
  return {
    color: $theme.colors.primary
  };
});

(0, _react3.storiesOf)('Introduction', module).add('Welcome', function () {
  return _react2.default.createElement(
    Root,
    null,
    _react2.default.createElement(
      'svg',
      {
        width: '142',
        height: '40',
        viewBox: '0 0 142 40',
        xmlns: 'http://www.w3.org/2000/svg'
      },
      _react2.default.createElement('path', {
        d: 'M12.8707 15.5547C14.2476 16.2432 14.9361 17.5865 14.9361 19.5847V20.4159C14.9361 21.9104 14.5415 23.0522 13.7523 23.8414C12.9631 24.6138 11.8213 25 10.3268 25H3.42548C3.14002 25 2.91334 24.9244 2.74542 24.7733C2.5943 24.6054 2.51873 24.3787 2.51873 24.0933V9.15716C2.51873 8.8717 2.5943 8.65341 2.74542 8.50229C2.91334 8.33437 3.14002 8.25041 3.42548 8.25041H9.99938C11.2923 8.25041 12.283 8.58624 12.9715 9.25791C13.6599 9.92957 14.0042 10.9035 14.0042 12.1796V12.8597C14.0042 14.0351 13.6264 14.9335 12.8707 15.5547ZM4.33222 15.0258H10.3268H10.4779H10.5283C11.0992 15.0258 11.519 14.8327 11.7877 14.4465C12.0563 14.0603 12.1907 13.5314 12.1907 12.8597V12.1796C12.1907 11.4072 12.0228 10.8615 11.6869 10.5425C11.3511 10.2234 10.7886 10.0639 9.99938 10.0639H4.33222V15.0258ZM13.1226 19.5847C13.1226 18.594 12.9043 17.8888 12.4677 17.469C12.0479 17.0492 11.3343 16.8393 10.3268 16.8393H4.33222V23.1865H10.3268C11.3175 23.1865 12.0312 22.9766 12.4677 22.5568C12.9043 22.1202 13.1226 21.4066 13.1226 20.4159V19.5847ZM31.7441 23.7154C31.8113 23.8498 31.8449 23.9925 31.8449 24.1436C31.8449 24.4963 31.6518 24.7481 31.2656 24.8993C31.1144 24.9664 30.9633 25 30.8122 25C30.4764 25 30.2329 24.8069 30.0818 24.4207L28.5957 20.8693H20.6113L19.1756 24.4207C19.0245 24.8069 18.7726 25 18.42 25C18.2689 25 18.1262 24.9664 17.9918 24.8993C17.5888 24.7481 17.3873 24.4963 17.3873 24.1436C17.3873 23.9925 17.4209 23.8498 17.4881 23.7154L23.5582 8.95566C23.7597 8.4855 24.104 8.25041 24.5909 8.25041H24.6413C25.0947 8.25041 25.4221 8.4855 25.6236 8.95566L31.7441 23.7154ZM21.3418 19.0558H27.8401L24.5405 11.1218L21.3418 19.0558ZM38.7011 25C37.2403 25 36.1236 24.6894 35.3512 24.0681C34.5788 23.4468 34.1254 22.4897 33.9911 21.1967C33.9743 20.8945 34.0415 20.6678 34.1926 20.5167C34.3437 20.3487 34.5704 20.2648 34.8727 20.2648C35.4268 20.2648 35.7374 20.567 35.8046 21.1715C35.9054 21.9271 36.174 22.4561 36.6106 22.7583C37.0472 23.0438 37.744 23.1865 38.7011 23.1865H42.3281C43.1005 23.1865 43.6966 23.1026 44.1164 22.9346C44.5362 22.7499 44.8301 22.4477 44.998 22.0279C45.1827 21.6081 45.275 21.0204 45.275 20.2648C45.275 19.4924 45.1827 18.8963 44.998 18.4765C44.8133 18.0567 44.511 17.7544 44.0912 17.5697C43.6714 17.385 43.0837 17.2927 42.3281 17.2927H39.079C37.5509 17.2927 36.4091 16.9233 35.6535 16.1844C34.9146 15.4288 34.5452 14.287 34.5452 12.7589C34.5452 11.2141 34.9146 10.0807 35.6535 9.35866C36.3923 8.61983 37.5257 8.25041 39.0538 8.25041H42.2526C43.6295 8.25041 44.6789 8.54427 45.401 9.13197C46.1398 9.70288 46.5764 10.5928 46.7107 11.8018C46.7443 12.1041 46.6771 12.3392 46.5092 12.5071C46.3581 12.6582 46.1314 12.7338 45.8292 12.7338C45.5437 12.7338 45.3254 12.6666 45.1743 12.5323C45.04 12.3811 44.9476 12.1545 44.8972 11.8522C44.8133 11.1973 44.5698 10.7356 44.1668 10.4669C43.7638 10.1982 43.1257 10.0639 42.2526 10.0639H39.0538C38.0295 10.0639 37.3242 10.257 36.938 10.6432C36.5518 11.0126 36.3587 11.7179 36.3587 12.7589C36.3587 13.7832 36.5518 14.4969 36.938 14.8999C37.341 15.2861 38.0547 15.4792 39.079 15.4792H42.3281C43.9569 15.4792 45.1575 15.8738 45.9299 16.663C46.7023 17.4354 47.0885 18.636 47.0885 20.2648C47.0885 21.8936 46.7023 23.0942 45.9299 23.8666C45.1575 24.6222 43.9569 25 42.3281 25H38.7011ZM61.7145 23.1865C62 23.1865 62.2183 23.2705 62.3694 23.4384C62.5373 23.5895 62.6213 23.8078 62.6213 24.0933C62.6213 24.3787 62.5373 24.6054 62.3694 24.7733C62.2183 24.9244 62 25 61.7145 25H52.5211C52.2357 25 52.009 24.9244 51.8411 24.7733C51.6899 24.6054 51.6144 24.3787 51.6144 24.0933V9.15716C51.6144 8.8717 51.6899 8.65341 51.8411 8.50229C52.009 8.33437 52.2357 8.25041 52.5211 8.25041H61.7145C62 8.25041 62.2183 8.33437 62.3694 8.50229C62.5373 8.65341 62.6213 8.8717 62.6213 9.15716C62.6213 9.44262 62.5373 9.6693 62.3694 9.83722C62.2183 9.98834 62 10.0639 61.7145 10.0639H53.4279V15.6303H58.7424C59.0279 15.6303 59.2462 15.7143 59.3973 15.8822C59.5652 16.0333 59.6491 16.2516 59.6491 16.5371C59.6491 16.8225 59.5652 17.0492 59.3973 17.2171C59.2462 17.3682 59.0279 17.4438 58.7424 17.4438H53.4279V23.1865H61.7145Z',
        transform: 'translate(50.251 4.2262)',
        fill: '#000'
      }),
      _react2.default.createElement('path', {
        d: 'M7.7577 25C5.87705 25 4.49174 24.555 3.60179 23.6651C2.71184 22.7751 2.26686 21.3898 2.26686 19.5092V9.15716C2.26686 8.8717 2.34242 8.65341 2.49355 8.50229C2.66146 8.33437 2.88815 8.25041 3.17361 8.25041C3.45906 8.25041 3.67735 8.33437 3.82848 8.50229C3.99639 8.65341 4.08035 8.8717 4.08035 9.15716V19.5092C4.08035 20.4495 4.1895 21.1883 4.40779 21.7256C4.64287 22.2462 5.02068 22.624 5.54122 22.8591C6.07855 23.0774 6.81738 23.1865 7.7577 23.1865H10.7802C11.7205 23.1865 12.4509 23.0774 12.9715 22.8591C13.5088 22.624 13.8866 22.2462 14.1049 21.7256C14.34 21.1883 14.4575 20.4495 14.4575 19.5092V9.15716C14.4575 8.8717 14.5331 8.65341 14.6842 8.50229C14.8521 8.33437 15.0788 8.25041 15.3643 8.25041C15.6497 8.25041 15.868 8.33437 16.0192 8.50229C16.1871 8.65341 16.271 8.8717 16.271 9.15716V19.5092C16.271 21.3898 15.8261 22.7751 14.9361 23.6651C14.0629 24.555 12.6776 25 10.7802 25H7.7577ZM21.7198 25C21.1153 25 20.813 24.6978 20.813 24.0933V9.15716C20.813 8.55266 21.1153 8.25041 21.7198 8.25041C22.3243 8.25041 22.6265 8.55266 22.6265 9.15716V24.0933C22.6265 24.6978 22.3243 25 21.7198 25Z',
        transform: 'translate(116.864 4.22583)',
        fill: 'var(--bui-colors-textAlt)'
      }),
      _react2.default.createElement('path', {
        d: 'M0 3.24948e-05L10.6416 0L10.6416 10.6416L4.86108e-05 10.6416L0 3.24948e-05Z',
        transform: 'translate(20.1318 12.5) scale(1.00328 0.99671) rotate(45)',
        fill: '#276ef1'
      }),
      _react2.default.createElement('ellipse', {
        cx: '2.51648',
        cy: '2.5',
        rx: '2.51648',
        ry: '2.5',
        transform: 'translate(8.80762 8.75)',
        fill: '#276ef1',
        fillOpacity: '0.5'
      }),
      _react2.default.createElement('ellipse', {
        cx: '2.51648',
        cy: '2.5',
        rx: '2.51648',
        ry: '2.5',
        transform: 'translate(0 17.5)',
        fill: '#276ef1'
      }),
      _react2.default.createElement('ellipse', {
        cx: '2.51648',
        cy: '2.5',
        rx: '2.51648',
        ry: '2.5',
        transform: 'translate(8.80762 26.25)',
        fill: '#276ef1',
        fillOpacity: '0.5'
      }),
      _react2.default.createElement('ellipse', {
        cx: '2.51648',
        cy: '2.5',
        rx: '2.51648',
        ry: '2.5',
        transform: 'translate(17.6152 35)',
        fill: '#276ef1'
      }),
      _react2.default.createElement('ellipse', {
        cx: '2.51648',
        cy: '2.5',
        rx: '2.51648',
        ry: '2.5',
        transform: 'translate(26.4231 26.25)',
        fill: '#276ef1',
        fillOpacity: '0.5'
      }),
      _react2.default.createElement('ellipse', {
        cx: '2.51648',
        cy: '2.5',
        rx: '2.51648',
        ry: '2.5',
        transform: 'translate(35.2307 17.5)',
        fill: '#276ef1'
      }),
      _react2.default.createElement('ellipse', {
        cx: '2.51648',
        cy: '2.5',
        rx: '2.51648',
        ry: '2.5',
        transform: 'translate(26.4231 8.75)',
        fill: '#276ef1',
        fillOpacity: '0.5'
      }),
      _react2.default.createElement('ellipse', {
        cx: '2.51648',
        cy: '2.5',
        rx: '2.51648',
        ry: '2.5',
        transform: 'translate(17.6152)',
        fill: '#276ef1'
      })
    ),
    _react2.default.createElement(
      'h1',
      null,
      'Welcome!'
    ),
    _react2.default.createElement(
      P,
      null,
      'We\'re still in development but feel free to browse around and leave feedback. Code is available at',
      ' ',
      _react2.default.createElement(
        Anchor,
        {
          href: 'https://github.com/uber-web/baseui',
          target: '_blank',
          rel: 'noopener noreferrer'
        },
        'uber-web/baseui'
      ),
      ' ',
      'on Github.'
    )
  );
});